<?php

//
// Mig - A general purpose photo gallery management system.
//
// Copyright (c) 2000-2005, Daniel M. Lowe
// Copyright (c) 2005-2022, Boris Wachtmeister
// All rights reserved.
//
// https://mig.wcht.de/
//

$version = '1.7.1';


//
// LICENSE INFORMATION
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
//
// The name of Daniel M. Lowe may not be used to endorse or promote products
// derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// END OF LICENSE INFORMATION
//


//
// Please see the files in the docs subdirectory.
//
// Do not modify this file directly.  Please see docs/text/install.txt
// or docs/html/install.html for installation directions.  Most things
// you'd want to customize can be customized outside of this file.
// (Exception: if you need to use the $pathConvert* features those should
// be modified here).
//
// If you find that is not the case, and you hack in support for some
// feature you want to see in Mig, please contact me with a code diff and
// if I agree that it is useful to the general public, I will incorporate
// your code into the main code base for distribution.  If you have GNU
// diff, a unified diff is best (diff -u), if you don't, then contextual
// diff works too (diff -c).
//
// If I don't incorporate it I may very well offer it as "contributed"
// code that others can download if they wish to do so.
//

?>
<?php

// -----------------------------------------------------------------
//                    MODIFYING THE INCLUDE PATH
// -----------------------------------------------------------------
//
// This is not normally required, but in some peculiar setups you
// are forced to use non-real paths in order to use the include()
// function.  That is, you have a real path, for instance:
//      /u25/vhost/www12345/www/mig/myfile.php
// but the ISP has PHP installed such that you need to tell include()
// to use this virtual path instead to the same file:
//     /mig/myfile.php
//
// To address this, the following three options exist.  Do not use
// these unless you have to, and know you have to.  If you don't
// need to use them and do anyway, you'll probably break Mig.
//
// $pathConvertFlag
//     This is a boolean to determine if conversion is needed.  Only
//     set this to TRUE if you know you need to do so.
//
// Defaults to FALSE.
//
// Example:
//     $pathConvertFlag = FALSE;
//

$pathConvertFlag = FALSE;

//
// $pathConvertRegex
//     This is a regular expression string, used to tell Mig how to
//     modify your include path.  If you don't know regular expressions,
//     here's probably all you need to know:
//     
//     ^    means "beginning of string"
//     .*   is a wildcard for any number of characters of any kind
//          (note - it will also match 0 characters in some cases)
//          
//     Going back to the earlier example, if you want to start out
//     with this: 
//         /u25/vhost/www12345/www/mig/myfile.php
//     and end up with this:
//         /mig/myfile.php
//         
//     You could define:
//         $pathConvertFlag = TRUE;
//         $pathConvertRegex = "#^.*/www/#";
//         $pathConvertTarget = "/";
//         
//     So the regex would match this:  /u25/vhost/www12345/www/
//     and replace it with a single slash... resulting in:
//         /mig/myfile.php 
//
// Defaults to an empty string.
//         
// Example:
//     $pathConvertRegex = "#^.*/www/#";
//     

$pathConvertRegex = "";

//
// $pathConvertTarget
//     This is the target string, which replaces the portion matched by
//     the regex.  Usually this should be "/", but it can be changed.
//     See the notes for $convertPathRegex (above) for more details.
//
// Defaults to an empty string.
//
// Example:
//     $pathConvertTarget = "/";
//

$pathConvertTarget = "";

// -----------------------------------------------------------------
// End of "INCLUDE PATH" modification section
// -----------------------------------------------------------------


?>
<?php

// Defaults - these values can be over-ridden using config.php
//

$homeLabel                  = "Unset home label";
$homeLink                   = "https://mig.wcht.de/unsetHomeLink";
$thumbExt                   = "";
$commentFilePerImage        = FALSE;
$commentFileShortComments   = FALSE;
$distURL                    = 'https://mig.wcht.de/';
$exifFormatString           = '|%c|';
$fileInfoFormatString       = array();
$fileInfoFormatString['image'] = "%n<br>(%i, %s)";
$fileInfoFormatString['audio'] = "%n<br>(%s)";
$fileInfoFormatString['video'] = "%n<br>(%s)";
$folderNameLength           = 15;
$folderSortType             = 'default';
$ignoreDotDirectories       = FALSE;
$imagePopLocationBar        = FALSE;
$imagePopMaxHeight          = 480;
$imagePopMaxWidth           = 640;
$imagePopMenuBar            = FALSE;
$imagePopToolBar            = FALSE;
$imagePopType               = 'reuse';
$imagePopup                 = FALSE;
/** @var array<string, string> */
$jumpMap                    = array();
$largeLinkFromMedium        = TRUE;
$largeLinkUseBorders        = FALSE;
$largeSubdir                = 'large';
$maintAddr                  = 'webmaster@mydomain.com';
$markerLabel                = 'th';
$markerType                 = 'suffix';
$maxFolderColumns           = 2;
$maxThumbColumns            = 4;
$maxThumbRows               = 5;
$mig_language               = 'en';
$nextFormatString           = '%l';
$noThumbs                   = FALSE;
$omitImageName              = FALSE;
$pageTitle                  = 'My Photo Album';
$prevFormatString           = '%l';
$randomFolderThumbs         = FALSE;
$showShortOnThumbPage       = FALSE;
$sortType                   = 'default';
$suppressAltTags            = FALSE;
$suppressImageInfo          = FALSE;
$thumbSubdir                = 'thumbs';
$useLargeImages             = FALSE;
$useRealRandThumbs          = TRUE;
$useThumbSubdir             = TRUE;
$viewFolderCount            = FALSE;
$imageFilenameRegexpr       = '=^[^<>/]*$=';
$currDirNameRegexpr         = '=^([^<>]|\.\.)*$=';
$migCharset                 = 'UTF-8';
$httpContentType            = "text/html; charset=$migCharset";
$onlySendIfXhtmlIsAccepted  = FALSE;
$music_icon                 = 'music.png';
$movie_icon                 = 'movie.png';
$folder_icon                = 'folder.png';
$nothumb_icon               = 'no_thumb.png';
$showTotalImagesString      = true;
$error_reporting            = error_reporting() & ~E_NOTICE;
$image_extensions           = array('jpg', 'jpeg', 'jpe', 'gif', 'png');
$video_extensions           = array(
        'mov',             // Apple Quicktime
        'avi',             // AVI-container
        'mpg', 'mpeg',     // MPEG video
        'wmv',             // Windows Media video
        'mp4',             // MPEG-4 video
        'swf',             // Shockwave Flash
        'flv',             // Flash Video
        'rm',              // Realvideo
        'divx',            // DivX
    );
$audio_extensions           = array(
        'mp3',             // MPEG-3 audio
        'wav',             // WAV audio
        'ra', 'ram',       // Realaudio
        'wma',             // Microsoft Media Audio
        'ogg',             // ogg-container (flac, vorbis)
        'flac',            // Free Lossless Audio Codec
        'aac',             // Advanced Audio Coding
        'mpc', 'mp+',      // Musepack
    );
$migOpenBasedir = FALSE;
$migOpenBasedirExtraDirs = array();
$albumRoot = '/albums';

?>
<?php

// buildBackLink() - Create a "back one step" link.

function buildBackLink ( $unsafe_currDir, $type )
{
    global $mig_config;

    $label = '';

    // $type notes whether we want a "back" link or "up one level" link.
    if ($type == 'back' or !empty($mig_config['nothumbs'])) {
        $label = $mig_config['lang']['up_one'];
    } elseif ($type == 'up') {
        if ($mig_config['pagetype'] == 'large') {
            $label = $mig_config['lang']['largeview'];
        } elseif ($mig_config['pagetype'] == 'image') {
            $label = $mig_config['lang']['thumbview'];
        }
    }

    // don't send a link back if we're a the root of the tree
    if ($unsafe_currDir == '.') {
        if (!empty($mig_config['homelink'])) {

            if (empty($mig_config['homelabel'])) {
                $homeLabel = $mig_config['homelink'];
            } else {
                // Get rid of spaces due to silly formatting in MSIE
                $homeLabel = str_replace(' ', '&nbsp;', $mig_config['homelabel']);
            }

            // Build a link to the "home" page
            $retval  = '&nbsp;[&nbsp;<a href="'
                     . $mig_config['homelink'] . '">'
                     . $mig_config['lang']['backhome'] . '&nbsp;'
                     . $homeLabel . '</a>&nbsp;]&nbsp;';
        } else {
            $retval = '<!-- no backLink in root tree -->';
        }
        return $retval;
    }

    // Trim off the last directory, so we go "back" one.
    $unsafe_newCurrDir = preg_replace('#/[^/]+$#', '', $unsafe_currDir);
    $newCurrDir = migURLencode($unsafe_newCurrDir);

    $retval = '<a href="'
            . $mig_config['baseurl'] . '?currDir=' . $newCurrDir;
    if (!empty($mig_config['startfrom'])) {
        $retval .= '&amp;startFrom=' . $mig_config['startfrom'];
    }
    if (!empty($mig_config['mig_dl'])) {
        $retval .= '&amp;mig_dl=' . $mig_config['mig_dl'];
    }
    if ($mig_config['pagetype'] == 'large') {
        $retval .= '&amp;pageType=image&amp;image=' . $mig_config['enc_image'];
    }
    $retval .= '">' . $label . '</a>';

    return $retval;

}   // -- End of buildBackLink()

?>
<?php

// buildDirList() - Build list of directories for display.

function buildDirList ( $unsafe_currDir, $maxColumns, $presorted, $ficons )
{
    global $mig_config;

    $old_unsafe_CurrDir = $unsafe_currDir;         // Stash this to build full path

    // Create a URL-encoded version of $unsafe_currDir
    $unsafe_currDir = rawurldecode($unsafe_currDir);
    $enc_currDir = migHtmlSpecialChars($unsafe_currDir);

    $directories = array ();                    // prototypes
    $counts = array ();
    $countdir = array ();
    $samples = array ();
    $filedates = array ();

    $unsafe_abs_currDir = $mig_config['albumdir'].'/'.$unsafe_currDir;
    if (!is_dir($unsafe_abs_currDir)) {
        exit("ERROR: no such currDir '$enc_currDir'"); // should already be captured by body.php...
    }

    $dir = opendir($unsafe_abs_currDir);
    while ($file = readdir($dir)) {
        if ($file == '.' || $file == '..') {
            continue; // skip self and parent
        }

        // Only pay attention to directories
        $unsafe_abs_childDir = $unsafe_abs_currDir.'/'.$file;
        if (!is_dir($unsafe_abs_childDir)) {
            continue;
        }

        // Ignore presorted items
        if (isset($presorted[$file])) {
            continue;
        }

        // Ignore directories whose name begins with "." if the
        // appropriate option is set
        if ($mig_config['ignoredotdirectories'] && preg_match('#^\.#', $file)) {
            continue;
        }

        // Ignore directories whose name does not match currDirNameRegexpr
        if (!preg_match($mig_config['currDirNameRegexpr'], $file)) {
            continue;
        }

        // If we got here, store it as a valid directory
        $directories[$file] = TRUE;

        // And stash a timestamp
        if (preg_match('#bydate.*#', $mig_config['foldersorttype'])) {
            $timestamp = filemtime($unsafe_abs_childDir);
            $filedates["$timestamp-$file"] = $file;
        }
    }

    closedir($dir);

    $directoryList = '';

    // If we have directories, start a table
    if ($directories) {
        $directoryList .= "\n" . '   <table summary="Folder Links"'
                        . ' border="0" cellspacing="0"><tbody>';
    }

    ksort($directories);    // sort so we can yank them in sorted order

    if ($mig_config['foldersorttype'] == 'bydate-ascend') {
        ksort($filedates);

    } elseif ($mig_config['foldersorttype'] == 'bydate-descend') {
        krsort($filedates);
    }

    // Join the two sorted lists together into a single list
    if (preg_match('#bydate.*#', $mig_config['foldersorttype'])) {
        foreach (array_values($filedates) as $file) {
            $presorted[$file] = TRUE;
        }

    } else {
        foreach (array_keys($directories) as $file) {
            $presorted[$file] = TRUE;
        }
    }

    // Make sure hidden items aren't displayed
    foreach ($mig_config['hidden'] as $file => $junk) {
        unset ($presorted[$file]);
    }

    // Iterate through all folders now that we have our final list.
    foreach ($presorted as $file => $junk) {

        $unsafe_folder = $mig_config['albumdir'].'/'.$unsafe_currDir.'/'.$file;

        // Calculate how many images in the folder if desired
        if ($mig_config['viewfoldercount']) {
            $counts[$file] = getNumberOfImages($unsafe_folder);
            $countdir[$file] = getNumberOfDirs($unsafe_folder);
        }

        // Handle random folder thumbnails if desired
        if ($mig_config['randomfolderthumbs']) {
            $samples[$file] = getRandomThumb($file, $unsafe_folder, $unsafe_currDir);
        }
    }

    // Track columns
    $row = 0;
    $col = 0;
    --$maxColumns;  // Tricks $maxColumns into working since it
                    // really starts at 0, not 1

    foreach ($presorted as $file => $junk) {

        // Start a new row if appropriate
        if ($col == 0) {
            $directoryList .= "\n   <tr>";
        }

        // Surmise the full path to work with
        $unsafe_newCurrDir = $old_unsafe_CurrDir . '/' . $file;

        // URL-encode the directory name in case it contains spaces
        // or other weirdness.
        $enc_file = migURLencode($unsafe_newCurrDir);

        // Build the link itself for re-use below
        $linkURL = '<a href="'
                 . $mig_config['baseurl']
                 . '?pageType=folder&amp;currDir=' . $enc_file;
        if ($mig_config['mig_dl']) {
            $linkURL .= '&amp;mig_dl=' . $mig_config['mig_dl'];
        }
        $linkURL .= '">';

        // Reword $file so it doesn't allow wrapping of the label
        // (fixes odd formatting bug in MSIE).
        // Also, render _ as a space.
        // Also, shorten filename length if using random thumbs,
        // to make the table cleaner
        $nbspfile = $file;
        if ($mig_config['randomfolderthumbs']
            && strlen($nbspfile) > $mig_config['foldernamelength']) {
                $nbspfile = substr($nbspfile,0,$mig_config['foldernamelength']-1)
                          . '(..)';
        }
        $nbspfile = str_replace(' ', '&nbsp;', migHtmlSpecialChars($nbspfile));
        $nbspfile = str_replace('_', '&nbsp;', $nbspfile);

        if ($mig_config['randomfolderthumbs']) {
            $folderTableClass = 'folderthumbs';
            $folderTableAlign = 'center';
        } else {
            $folderTableClass = 'foldertext';
            $folderTableAlign = 'left';
        }

        // Build the full link (icon plus folder name) and tack it on
        // the end of the list.
        $directoryList .= "\n" . '     <td valign="middle" class="'
                        . $folderTableClass . '" align="'
                        . $folderTableAlign . '">'
                        . $linkURL
                        . '<img src="';

        if (!empty($mig_config['usethumbfile'][$file])) {
            // Found a UseThumb line in mig.cf - process as such

            $fname = getFileName($mig_config['usethumbfile'][$file]);
            if ($mig_config['thumbext']) {
                $fext = $mig_config['thumbext'];
            } else {
                $fext = getFileExtension($mig_config['usethumbfile'][$file]);
            }

            $directoryList .= $mig_config['albumurlroot'] . '/' . $enc_currDir
                            . '/' . migHtmlSpecialChars($file) . '/';
            if ($mig_config['usethumbsubdir']) {
                $directoryList .= $mig_config['thumbsubdir'] . '/'
                                . $fname . '.' . $fext;
            } else {
                if ($mig_config['markertype'] == 'prefix') {
                    $directoryList .= $mig_config['markerlabel'] . '_' . $fname;
                } else {
                    $directoryList .= $fname . '_' . $mig_config['markerlabel'];
                }
                $directoryList .= '.' . $fext;
            }
        } elseif (isset($ficons[$file])) {
            // Found a FolderIcon line in mig.cf - process as such
            $directoryList .= $mig_config['imagedir'] . '/' . $ficons[$file];
        } elseif (isset($samples[$file])) {
            // Using a random thumbnail as the folder icon
            $directoryList .= $samples[$file];
        } else {
            // Otherwise, we're out a thumbnail; use the generic
            // folder icon as a last resort
            $directoryList .= $mig_config['imagedir'] . '/' . $mig_config['folder_icon'];
        }

        // Define a separator of either a space or a line break,
        // depending on whether we're using a random thumbnail or not.
        // (Use a line break if random thumbnail is present so the name
        // appears underneath it - also use a line break if the thumbnail
        // was specified).
        if (isset($samples[$file]) || !empty($mig_config['usethumbfile'][$file])) {
            $sep = '<br />';
        } else {
            $sep = '&nbsp;';
        }

        // Display _ as space
        $altlabel = str_replace('_', ' ', migHtmlSpecialChars($file));

        // Output the rest of the link, label, etc.
        $directoryList .= '" '
                       . 'border="0" alt="' . $altlabel . '"/></a>' . $sep
                       . $linkURL . $nbspfile . '</a>';

        // Display counts if appropriate
        if ($mig_config['viewfoldercount'] &&
                (($counts[$file] > 0) || ($countdir[$file] > 0)) )
        {
            $directoryList .= $sep . '<acronym title="(folders/files)">('
                            . $countdir[$file] . '/' . $counts[$file]
                            . ')</acronym>';
        }

        // Don't forget to close the table cell
        $directoryList .= '</td>';

        // Keep track of what row/column we're on
        if ($col == $maxColumns) {
            $directoryList .= "\n   </tr>";
            ++$row;
            $col = 0;
        } else {
            ++$col;
        }
    }

    // If there aren't any subfolders to look at, then just say so.
    if ($directoryList == '' || preg_match('#<tbody>$#', $directoryList)) {
        return '';
    } elseif (!preg_match('#</tr>$#i', $directoryList)) {
        // Stick a </tr> on the end if it isn't there already, and close
        // the table.
        $directoryList .= "\n   </tr>\n  </tbody></table>";
    } else {
        // Close the table.
        $directoryList .= "\n  </tbody></table>";
    }

    return $directoryList;

}   // -- End of buildDirList()

?>
<?php

// buildImageList() - Creates a list of images for display.

function buildImageList ( $unsafe_currDir, $maxColumns, $maxRows,
                          $presorted, $description, $short_desc )
{
    global $mig_config;

    if (is_dir($mig_config['albumdir'].'/'.$unsafe_currDir)) {
        $dir = opendir($mig_config['albumdir'].'/'.$unsafe_currDir);
    } else {
        exit("ERROR: no such currDir '" . migHtmlSpecialChars($unsafe_currDir) . "'<br>");
    }

    // URL-encoded version of currDir
    $enc_currDir = migURLencode($unsafe_currDir);

    $row = 0;               // Counters for the table formatting
    $col = 0;

    --$maxColumns;          // Tricks maxColumns into working since it
                            // really starts at 0, not 1.

    --$maxRows;             // same for rows

    // prototype the arrays
    $imagefiles     = array ();
    $filedates      = array ();

    $thumbsInFolder = 0;
    $imageList      = '';
    $pageBlock      = '';

    // Count presorted images for pagination purposes
    if ($presorted) {
        foreach ($presorted as $x => $y) {
            ++$thumbsInFolder;
        }
    }

    $markerLabel = $mig_config['markerlabel'];
    while ($file = readdir($dir)) {
        if ($file == '.' || $file == '..') {
            continue; // skip self and parent
        }

        // Skip over thumbnails
        if (!$mig_config['usethumbsubdir']) {
                         // unless $useThumbSubdir is set,
                         // then don't waste time on this check

            if ($mig_config['markertype'] == 'suffix' && preg_match("#_$markerLabel\.[^.]+$#", $file)
                && getFileType($file)) {
                    continue;
            }

            if ($mig_config['markertype'] == 'prefix' && preg_match("#^$markerLabel\_#", $file)) {
                continue;
            }

        }

        // We'll look at this one only if it's a file
        // and it matches our list of approved extensions
        $abs_currDir = $mig_config['albumdir'] . '/' . $unsafe_currDir . '/' . $file;
        if (is_file($abs_currDir)
            && !isset($presorted[$file]) && getFileType($file)
            && preg_match($mig_config['imageFilenameRegexpr'], $file)) {

            // Increase thumb counter
            ++$thumbsInFolder;

            // Stash file in an array
            $imagefiles[$file] = TRUE;

            // and stash a timestamp as well if needed
            if (preg_match('#bydate.*#', $mig_config['sorttype'])) {
                $timestamp = filemtime($abs_currDir);
                $filedates["$timestamp-$file"] = $file;
            }
        }
    }

    ksort($imagefiles); // sort, so we get a sorted list to stuff onto the
                        // end of $presorted

    if ($mig_config['sorttype'] == 'bydate-ascend') {
        ksort($filedates);

    } elseif ($mig_config['sorttype'] == 'bydate-descend') {
        krsort($filedates);
    }

    // Join the two sorted lists together into a single list
    if (preg_match('#bydate.*#', $mig_config['sorttype'])) {
        foreach (array_values($filedates) as $file) {
            $presorted[$file] = TRUE;
        }

    } else {
        foreach (array_keys($imagefiles) as $file) {
            $presorted[$file] = TRUE;
        }
    }

    // Make sure hidden items don't show up
    foreach ($mig_config['hidden'] as $file => $junk) {
        unset ($presorted[$file]);
    }

    // If there are images, start the table
    if ($thumbsInFolder) {
        $imageList .= "\n  " . '<table summary="Image Links" border="0"'
                    . ' cellspacing="0"><tbody>';
    }

    // Set up pagination environment
    $max_col = $maxColumns + 1;
    $max_row = $maxRows + 1;
    $firstThumb = $mig_config['startfrom'] * $max_col * $max_row;
    // This rounds off any fractional part
    $pages = ceil($thumbsInFolder / ($max_col * $max_row));

    // show last page if $startfrom to big
    if ($thumbsInFolder<$firstThumb) {
        $mig_config['startfrom']=$pages-1;
        $firstThumb = $mig_config['startfrom'] * $max_col * $max_row;
    }

    // Handle pagination
    if ($thumbsInFolder > ($max_col * $max_row)) {

        if ($mig_config['startfrom']) {
            $start_img = ($mig_config['startfrom'] * $max_col * $max_row) + 1;

            if (($start_img+($max_col*$max_row)-1) >= $thumbsInFolder) {
                // This must be the last page.
                $end_img = $thumbsInFolder;
            } else {
                // Not the first, not last - some middle page.
                $end_img = ($mig_config['startfrom'] + 1) * $max_col * $max_row;
            }

        } else {
            // Absence of startFrom means we're on page 1 (startFrom=0).
            // Therefore, we can easily calculate what we need.
            $start_img = 1;
            $end_img = $max_col * $max_row;
        }

        // Fetch template phrase to work with.
        if ($mig_config['showTotalImagesString']) {
            $phrase = $mig_config['lang']['total_images'];
            // %t is total images in folder
            $phrase = str_replace('%t', strval($thumbsInFolder), $phrase);
            // %s is start image
            $phrase = str_replace('%s', strval($start_img), $phrase);
            // %e is end image
            $phrase = str_replace('%e', strval($end_img), $phrase);
        } else {
            $phrase = '';
        }

        $pageBlock .= "\n" . '   <tr>' . "\n" . '    <td colspan="'
                    . $max_col . '" align="center"><small>' . $phrase;

        if ($mig_config['startfrom']) {
            $prevPage = $mig_config['startfrom'] - 1;

            $pageBlock .= '<a href="' . $mig_config['baseurl']
                        . '?pageType=folder&amp;currDir=' . $enc_currDir
                        . '&amp;startFrom=' . $prevPage;
            if ($mig_config['mig_dl']) {
                $pageBlock .= '&amp;mig_dl=' . $mig_config['mig_dl'];
            }
            $pageBlock .= '">&laquo;</a>&nbsp;&nbsp;';
        }

        for ($i = 1; $i <= $pages; ++$i) {
            if (floor(($i - 11) / 20) == (($i - 11) / 20)) {
                $pageBlock .= '<br />';
            }
            if ($i == ($mig_config['startfrom'] + 1)) {
                $pageBlock .= '<b>' . $i . '</b>&nbsp;&nbsp;';
            } else {
                $ib = $i - 1;
                $pageBlock .= '<a href="' . $mig_config['baseurl']
                            . '?pageType=folder&amp;currDir=' . $enc_currDir
                            . '&amp;startFrom=' . $ib;
                if ($mig_config['mig_dl']) {
                    $pageBlock .= '&amp;mig_dl=' . $mig_config['mig_dl'];
                }
                $pageBlock .= '">' . $i . '</a>&nbsp;&nbsp;';
            }
        }

        if (($mig_config['startfrom'] + 1) < $pages) {
            $nextPage = $mig_config['startfrom'] + 1;
            $pageBlock .= '<a href="' . $mig_config['baseurl']
                        . '?pageType=folder&amp;currDir=' . $enc_currDir
                        . '&amp;startFrom=' . $nextPage;
            if ($mig_config['mig_dl']) {
                $pageBlock .= '&amp;mig_dl=' . $mig_config['mig_dl'];
            }
            $pageBlock .= '">&raquo;</a>';
        }

        $pageBlock .= "</small></td>\n   </tr>";
    }

    $imageList .= $pageBlock;

    $thumbCounter = -1;

    foreach ($presorted as $file => $junk) {

        ++$thumbCounter;

        if ($thumbCounter >= $firstThumb && $row <= $maxRows) {

            // Only look at valid image types
            if (getFileType($file)) {

                // If this is a new row, start a new <TR>
                if ($col == 0) {
                    $imageList .= "\n   <tr>";
                }

                $img = buildImageURL($unsafe_currDir, $file, $description, $short_desc);
                $imageList .= $img;

                // Keep track of what row and column we are on
                if ($col == $maxColumns) {
                    $imageList .= "\n   </tr>";
                    ++$row;
                    $col = 0;
                } else {
                    ++$col;
                }
            }
        }
    }

    closedir($dir);

    $imageList .= $pageBlock;

    // If there aren't any images to work with, just say so.
    if ($imageList == '') {
        $imageList = '';
    } elseif (!preg_match('#</tr>$#i', $imageList)) {
        // Stick a </tr> on the end if it isn't there already and close
        // the table
        $imageList .= "\n  </tr>\n  </tbody></table>";
    } else {
        // Close the table.
        $imageList .= "\n  </tbody></table>";
    }

    return $imageList;

}   // -- End of buildImageList()

?>
<?php

function _addThumbExt($name, $unsafe_ext) {
    global $mig_config;
    if ($name) {
        if ($mig_config['thumbext']) {
            $name .= $mig_config['thumbext'];
        } else {
            $name .= $unsafe_ext;
        }
    }
    return $name;
}

// buildImageURL() - Create HTML link for a particular image.

function buildImageURL ($unsafe_currDir, $unsafe_filename, $description, $short_desc )
{
    global $mig_config;

    // Collect information about this object.
    $unsafe_fname  = getFileName($unsafe_filename);
    $unsafe_ext    = getFileExtension($unsafe_filename);
    $type       = getFileType($unsafe_filename);

    // URL-encoded the filename
    $enc_fname = rawurlencode($unsafe_fname);
    $enc_ext   = rawurlencode($unsafe_ext);

    // URL-encode currDir, keeping an old copy too
    $enc_oldCurrDir = rawurlencode($unsafe_currDir);
    $enc_currDir = migURLencode($unsafe_currDir);

    // local Filename of the thumb
    $local_thumbFile = '';
    if ($type == 'image') {
        $local_dir = $mig_config['albumdir'] . "/$unsafe_currDir/";
        if ($mig_config['usethumbsubdir']) {
            $local_thumbFile = $local_dir . $mig_config['thumbsubdir'] . "/$unsafe_fname.";
        } elseif ($mig_config['markertype'] == 'prefix') {
            $local_thumbFile = $local_dir . $mig_config['markerlabel'] . "_$unsafe_fname.";
        } elseif ($mig_config['markertype'] == 'suffix') {
            $local_thumbFile = $local_dir . $unsafe_fname . "_{$mig_config['markerlabel']}.";
        }

        // if a thumbnail could be there
        $local_thumbFile = _addThumbExt($local_thumbFile, $unsafe_ext);
    }

    // Only show a thumbnail if one exists.  Otherwise use a default
    // "generic" thumbnail image.

    $enc_thumbImage = '';
    if (file_exists($local_thumbFile) && $type == 'image') {
        $unsafe_thumbImage = '';
        $unsafe_path = $mig_config['albumurlroot'] . "/$unsafe_currDir/";
        if ($mig_config['usethumbsubdir']) {
            $unsafe_thumbImage = $unsafe_path . $mig_config['thumbsubdir'] . "/$unsafe_fname.";
        } elseif ($mig_config['markertype'] == 'prefix') {
            $unsafe_thumbImage = $unsafe_path . $mig_config['markerlabel'] . "_$unsafe_fname.";
        } elseif ($mig_config['markertype'] == 'suffix') {
            $unsafe_thumbImage = $unsafe_path . "{$unsafe_fname}_{$mig_config['markerlabel']}.";
        }

        // if a thumbnail could be there
        $unsafe_thumbImage = _addThumbExt($unsafe_thumbImage, $unsafe_ext);

        $enc_thumbImage = migURLencode($unsafe_thumbImage);

    } else {
        $newRoot = preg_replace('#/[^/]+$#', '', $mig_config['baseurl']);
        switch ($type) {
            case 'image':
                $enc_thumbImage = $newRoot . '/images/' . $mig_config['nothumb_icon'];
                break;
            case 'audio':
                $enc_thumbImage = $newRoot . '/images/' . $mig_config['music_icon'];
                break;
            case 'video':
                $enc_thumbImage = $newRoot . '/images/' . $mig_config['movie_icon'];
                break;
        }
    }

    // Get description, if any
    if ($mig_config['commentfileperimage']) {
        list($alt_desc, $desc) = getImageDescFromFile($enc_currDir, "$unsafe_fname.$unsafe_ext");
        // Get a conventional comment if there isn't one here.
        if (! $alt_desc) {
            list($alt_desc, $desc) = getImageDescription("$unsafe_fname.$unsafe_ext", $description, $short_desc);
        }
    } else {
        list($alt_desc, $desc) = getImageDescription("$unsafe_fname.$unsafe_ext", $description, $short_desc);
    }

    // If there's a full description but no alt, use the full as alt.
    if ($desc && !$alt_desc) {
        $alt_desc = $desc;
    }

    $alt_desc = strip_tags($alt_desc);

    $localFilename = $mig_config['albumdir'] . "/$unsafe_currDir/$unsafe_filename";

    // Figure out the size in bytes for display
    $imageFileSize = filesize($localFilename);

    $imageWidth = 0;
    $imageHeight = 0;
    if ($type == 'image') {
        // Figure out the size in pixels for display
        $imageProps = @GetImageSize($localFilename);
        if ($imageProps) {
            $imageWidth = $imageProps[0];
            $imageHeight = $imageProps[1];
        }
    }

    if ($imageFileSize > 1048576) {
       $imageFileSize = sprintf('%01.1f', $imageFileSize / 1024 / 1024) . 'MB';
    } elseif ($imageFileSize > 1024) {
        $imageFileSize = sprintf('%01.1f', $imageFileSize / 1024) . 'KB';
    } else {
       $imageFileSize = $imageFileSize . $mig_config['lang']['bytes'];
    }


    // Figure out thumbnail geometry
    $thumbHTML = '';
    if (file_exists($local_thumbFile) && $type == 'image') {
        $thumbProps = @GetImageSize($local_thumbFile);
        if ($thumbProps) {
            $thumbHTML = $thumbProps[3];
        }
    }

    // If not an image, just print a URL to the object
    // with a few extra trimmings.
    if ($type != 'image') {

        $url = "\n" . '    <td align="center" class="image"><a';
        if (! $mig_config['suppressalttags']) {
            $url .= ' title="' . $alt_desc . '"';
        }

        $url .= ' href="' . $mig_config['albumurlroot'] . '/' . $enc_currDir . '/'
              . $enc_fname . '.' . $enc_ext . '">'
              . '<img src="' . $enc_thumbImage . '" /></a>';


        // If $fileInfoFormatString is set, show the file info
        if ($mig_config['fileinfoformatstring']) {
            $url .= '<br />';

            $fileinfotable = array(
                'n' => migHtmlSpecialChars($unsafe_filename),
                's' => $imageFileSize
                // 'i' => $imageWidth.'x'.$imageHeight
            );
            $newstr=replaceString($mig_config['fileinfoformatstring'][$type],$fileinfotable);

            if (!$mig_config['nothumbs']) {
                $url .= $newstr;
            }
        }

        $url .= '</td>';

        return $url;

    // It's an image - jump through all the hoops
    } else {

        // beginning of the table cell
        $url = "\n" . '    <td align="center" class="image"><a';

        if (! $mig_config['suppressalttags']) {
            $url .= ' title="' . $alt_desc . '"';
        }

        $url .= ' href="';

        // set up the image pop-up if appropriate to do so
        if ($mig_config['imagepopup']) {
            $popup_width = $imageWidth + 30;
            $popup_height = $imageHeight + 150;

            // Add max size for popup window
            if ($popup_width > $mig_config['imagepopmaxwidth']) {
                $popup_width = $mig_config['imagepopmaxwidth'];
            }
            if ($popup_height > $mig_config['imagepopmaxheight']) {
                $popup_height = $mig_config['imagepopmaxheight'];
            }
            $url .= '#" onClick="window.open(\'';
        }

        $url .= $mig_config['baseurl'] . '?currDir='
             . $enc_currDir . '&amp;pageType=image&amp;image=' . $enc_fname . '.' . $enc_ext;

        if ($mig_config['startfrom']) {
            $url .= '&amp;startFrom=' . $mig_config['startfrom'];
        }

        if ($mig_config['mig_dl']) {
            $url .= '&amp;mig_dl=' . $mig_config['mig_dl'];
        }

        if ($mig_config['imagepopup']) {
            assert(isset($popup_width) && isset($popup_height));
            $url .= "','";

            if ($mig_config['imagepoptype'] == 'reuse') {
                $url .= 'mig_window_11190874';
            } else {
                $url .= 'mig_window_' . time() . '_' . $enc_fname;
            }

            $url .= "','width=$popup_width,height=$popup_height,"
                  . 'resizable=yes,scrollbars=1';

            // Set up various toolbar options if requested

            if ($mig_config['imagepoplocationbar']) {
                $url .= ',location=1';
            }
            if ($mig_config['imagepoptoolbar']) {
                $url .= ',toolbar=1';
            }
            if ($mig_config['imagepopmenubar']) {
                $url .= ',menubar=1';
            }

            $url .= "');return false;";
        }

        $url .= '">';

        // If $noThumbs is true, just print the image filename rather
        // than the <IMG> tag pointing to a thumbnail.
        if ($mig_config['nothumbs']) {
            $url .= "$enc_fname.$enc_ext";
        } else {
            $url .= '<img src="' . $enc_thumbImage . '"';
                // Only print the ALT tag if it's wanted.
                if (! $mig_config['suppressalttags']) {
                    $url .= ' alt="' . $alt_desc . '"';
                }

            $url .= ' class="imagethumb" ' . $thumbHTML . ' />';
        }

        $url .= '</a>';     // End the <A> element

        // If $fileInfoFormatString is set, show the image info
        if ($mig_config['fileinfoformatstring']) {
            $url .= '<br />';
            //replace variables of the fileinfoformatstring
            //       %n = Filename
            //       %s = FileSize
            //       %i = ImageSize
            $fileinfotable = array(
                'n' => migHtmlSpecialChars($unsafe_fname . '.' . $unsafe_ext),
                's' => $imageFileSize,
                'i' => $imageWidth > 0 ? $imageWidth . 'x' . $imageHeight : ''
            );

             $newstr=replaceString($mig_config['fileinfoformatstring'][$type],$fileinfotable);


             if (!$mig_config['nothumbs']) {
                $url .= $newstr;
            }
        }

        // If $showShortOnThumbPage is TRUE, show short comment
        if ($mig_config['showshortonthumbpage']) {
            $url .= '<br />';
            $url .= $alt_desc;
        }

        $url .= '</td>';        // Close table cell
        return $url;
    }

}   // -- End of buildImageURL()

?>
<?php

// buildLargeHrefStart() - Builds the text used for template keyword "largeHrefStart".

function buildLargeHrefStart ( $unsafe_currDir )
{
    global $mig_config;

    $newCurrDir = migURLencode($unsafe_currDir);

    $retval = '<a href="' . $mig_config['baseurl'] . '?currDir='
            . $newCurrDir . '&amp;pageType=large&amp;image=' . $mig_config['enc_image'];
    if ($mig_config['startfrom']) {
        $retval .= '&amp;startFrom=' . $mig_config['startfrom'];
    }
    if ($mig_config['mig_dl']) {
        $retval .= '&amp;mig_dl=' . $mig_config['mig_dl'];
    }
    $retval .= '">';

    return $retval;

}   // -- End of buildLargeHrefStart()

?><?php

// buildLargeLink() - Builds the text used for template keyword "largeLink".

function buildLargeLink( $unsafe_currDir )
{
    global $mig_config;

    $newCurrDir = migURLencode($unsafe_currDir);

    $retval = '<a href="' . $mig_config['baseurl'] . '?currDir='
            . $newCurrDir . '&amp;pageType=large&amp;image=' . $mig_config['enc_image'];
    if ($mig_config['startfrom']) {
        $retval .= '&amp;startFrom=' . $mig_config['startfrom'];
    }
    if ($mig_config['mig_dl']) {
        $retval .= '&amp;mig_dl=' . $mig_config['mig_dl'];
    }
    $retval .= '">' . $mig_config['lang']['largelink']
             . '</a>';

    return $retval;

}   // -- End of buildLargeLink()

?><?php
// buildNextPrevLinks() - Build links to the "next" and "previous" images.

/**
/* is used by buildNextPrevLinks()
*/
function _greyLink($text)
{
    return '<span class="inactivelink">'.$text.'</span>';
}

function _prevNextLink($text, $enc_currDir, $imgNr)
{
    global $mig_config;

    $link = '<a href="' . $mig_config['baseurl']
        . '?pageType=' . $mig_config['pagetype'] . '&amp;currDir=' . $enc_currDir
        . '&amp;image=' . $imgNr;
    if ($mig_config['startfrom']) {
        $link .= '&amp;startFrom=' . $mig_config['startfrom'];
    }
    if ($mig_config['mig_dl']) {
        $link .= '&amp;mig_dl=' . $mig_config['mig_dl'];
    }
    $link .= '">' . $text . '</a>';

    return $link;
}

// buildNextPrevLinks() - Build links to the "next" and "previous" images.

function buildNextPrevLinks ( $unsafe_currDir, $presorted )
{
    global $mig_config;

    if (is_dir($mig_config['albumdir']."/$unsafe_currDir")) {
        if ($mig_config['pagetype'] == 'large') {
            $dir = opendir($mig_config['albumdir']."/$unsafe_currDir/".$mig_config['largesubdir']);
        } else {
            $dir = opendir($mig_config['albumdir']."/$unsafe_currDir");
        }
    } else {
        exit("ERROR: no such currDir '" . migHtmlSpecialChars($unsafe_currDir) . "'<br>");
    }

    // Gather all files into an array
    $fileList  = array();
    $filedates = array();
    while ($file = readdir($dir)) {
        if ($file == '.' || $file == '..') {
            continue; // skip self and parent
        }

        $markerLabel = $mig_config['markerlabel'];

        // Ignore thumbnails
        if ($mig_config['markertype'] == 'prefix' && preg_match("#^{$markerLabel}_#", $file)) {
            continue;
        }

        if ($mig_config['markertype'] == 'suffix' && preg_match("#_$markerLabel\.[^.]+$#", $file)
            && getFileType($file)) {
                continue;
        }

        // Only look at valid image formats
        if (! getFileType($file)) {
            continue;
        }

        // Ignore the hidden images
        if (isset($mig_config['hidden'][$file])) {
            continue;
        }

        // Make sure this is a file, not a directory.
        // and make sure it isn't presorted
        $localFilename = $mig_config['albumdir'] . "/$unsafe_currDir/$file";
        if (is_file($localFilename) && ! isset($presorted[$file])) {
            $fileList[$file] = TRUE;
            // Store a date, too, if needed
            if (preg_match('#bydate.*#', $mig_config['sorttype'])) {
                $timestamp = filemtime($localFilename);
                $filedates["$timestamp-$file"] = $file;
            }
        }
    }

    closedir($dir);

    ksort($fileList);       // sort, so we see sorted results

    if ($mig_config['sorttype'] == 'bydate-ascend') {
        ksort($filedates);
    } elseif ($mig_config['sorttype'] == 'bydate-descend') {
        krsort($filedates);
    }

    // Generated final sorted list
    if (preg_match('#bydate.*#', $mig_config['sorttype'])) {
        // since $filedates is sorted by date, and date is
        // the key, the key is pointless to put in the list now.
        // so we store the value, not the key, in $presorted
        foreach (array_values($filedates) as $file) {
            $presorted[$file] = TRUE;
        }

    } else {
        // however, here we have real data in the key, so we push
        // the key, not the value, into $presorted.
        foreach (array_keys($fileList) as $file) {
            $presorted[$file] = TRUE;
        }
    }

    // Gather all files into an array

    $i = 1;                 // iteration counter, etc

    // Yes, position 0 is garbage.  Makes the math easier later.
    $fList = array ( 'blah' );

    $ThisImagePos = NULL;
    foreach (array_keys($presorted) as $file) {

        // If "this" is the one we're looking for, mark it as such.
        if ($file === $mig_config['unsafe_image']) {
            $ThisImagePos = $i;
        }

        $fList[$i] = $file;     // Stash filename in the array
        ++$i;                   // increment the counter, of course.
    }

    if (!is_int($ThisImagePos)) {
        exit('ABORT: image not found in $presorted');
    }

    --$i;                       // Get rid of the last increment...

    // Next is the next with a valid imageFilenameRegexpr behind $ThisImagePos.
    $tempThisImagePos = $ThisImagePos;
    while(isset($fList[$tempThisImagePos+1])
            && !preg_match($mig_config['imageFilenameRegexpr'], $fList[$tempThisImagePos+1])) {
        ++$tempThisImagePos;
    }
    if (isset($fList[$tempThisImagePos+1])) {
        $next = migURLencode($fList[$tempThisImagePos+1]);
    } else {
        $next = 'NA';
    }

    // Previous is the first image with a valid imageFilenameRegexpr
    // before $ThisImagePos

    $tempThisImagePos = $ThisImagePos;
    while(isset($fList[$tempThisImagePos-1])
            && !preg_match($mig_config['imageFilenameRegexpr'], $fList[$tempThisImagePos-1])) {
        --$tempThisImagePos;
    }

    if ($tempThisImagePos <= 1) {
        $prev = 'NA';
    } elseif (isset($fList[$tempThisImagePos-1])) {
        $prev = migURLencode($fList[$tempThisImagePos-1]);
    } else {
        $prev = 'NA';
    }

    // URL-encode currDir
    $enc_currDir = migURLencode($unsafe_currDir);

    //build the links:

    //first parse the prev/nextFormatStrings...

    $fileinfotable = array ( 'l' => $mig_config['lang']['previmage']
                           );
    $prevtext = replaceString($mig_config['prevformatstring'],$fileinfotable);

    $fileinfotable = array ( 'l' => $mig_config['lang']['nextimage']
                           );
    $nexttext = replaceString($mig_config['nextformatstring'],$fileinfotable);

    // If there is no previous image, show a greyed-out link
    if ($prev == 'NA') {
        $pLink = _greyLink($prevtext);
    } else { // else show a real link
        $pLink = _prevNextLink($prevtext, $enc_currDir, $prev);
    }


    // If there is no next image, show a greyed-out link
    if ($next == 'NA') {
        $nLink = _greyLink($nexttext);
    } else { // else show a real link
        $nLink = _prevNextLink($nexttext, $enc_currDir, $next);
    }

    // Current position in the list
    $currPos = '#' . $ThisImagePos . '&nbsp;of&nbsp;' . $i;

    return array( $nLink, $pLink, $currPos );

}   // -- End of buildNextPrevLinks()

?><?php

// buildTable() - Frames stuff in HTML table code so it's ready to use as a stand-alone
//                element in a template.

function buildTable ( $input, $tableclass, $tablesummary )
{
    $retval = '<table summary="' . $tablesummary
            . '" border="0" cellpadding="0" cellspacing="0"><tbody>'
            . "\n" . ' <tr><td class="' . $tableclass . '">'
            . $input . "\n" . ' </td></tr>' . "\n" . '</tbody></table>';

    return $retval;

}   // -- End of buildTable()

?><?php

// buildYouAreHere() - Build the "You are here" line for the top of each page.

function buildYouAreHere ( $unsafe_currDir )
{
    global $mig_config;

    $hereString = '';

    // Use $unsafe_workingCopy so we don't trash value of $unsafe_currDir
    $unsafe_workingCopy = $unsafe_currDir;

    // Loop until we get down to just the "."
    while ($unsafe_workingCopy != '.') {

        // $label is the "last" thing in the path. Strip up to that
        $label = preg_replace('#^.*/#', '', $unsafe_workingCopy);

        // Render underscores as spaces and turn spaces into &nbsp;
        $label = str_replace('_', '&nbsp;', $label);
        $label = str_replace(' ', '&nbsp;', $label);

        // Get a URL-encoded copy of $unsafe_workingCopy
        $encodedCopy = migURLencode($unsafe_workingCopy);

        if ($mig_config['enc_image'] == '' && $unsafe_workingCopy == $unsafe_currDir) {
            $url = '&nbsp;&gt;&nbsp;' . $label;
        } else {
            $url = '&nbsp;&gt;&nbsp;<a href="' . $mig_config['baseurl'] . '?currDir='
                 . $encodedCopy;
            if ($mig_config['mig_dl']) {
                $url .= '&amp;mig_dl=' . $mig_config['mig_dl'];
            }
            $url .= '">' . $label . '</a>';
        }

        // Strip the last piece off of $unsafe_workingCopy to go to next loop
        $unsafe_workingCopy = preg_replace('#/[^/]+$#', '', $unsafe_workingCopy);

        // Build up the final path over each loop iteration
        $x = $hereString;
        $hereString = $url . $x;
    }

    // If we're down to "." as our currDir then this is "Main"
    if ($unsafe_currDir == '.') {
        $url = $mig_config['lang']['main'];
        $x = $hereString;
        $hereString = $url . $x;

    // Or if we're not, then Main should be a link instead of just text
    } else {
        $url = '<a href="' . $mig_config['baseurl'] . '?currDir=' . $unsafe_workingCopy;
        if ($mig_config['mig_dl']) {
            $url .= '&amp;mig_dl=' . $mig_config['mig_dl'];
        }
        $url .= '">' . $mig_config['lang']['main'] . '</a>';
        $x = $hereString;
        $hereString = $url . $x;
    }

    // If there's an image, tack it onto the end of the hereString
    // unless we have $omitImageName set to TRUE
    if ($mig_config['enc_image'] != '' && ! $mig_config['omitimagename']) {
        $hereString .= '&nbsp;&gt;&nbsp;' . $mig_config['enc_image'];
    }

    return $hereString;

}   // -- End of buildYouAreHere()

?><?php

function _get_magic_quotes_gpc() {
    return function_exists('get_magic_quotes_gpc') ? @get_magic_quotes_gpc() : 0;
}

function string_starts_with($haystack, $needle) {
    if (function_exists('str_starts_with')) { // PHP >= 8.0
        return str_starts_with($haystack, $needle);
    }
    return strpos($haystack, $needle) === 0;
}

?><?php

// convertIncludePath() - Converts the path used by include() if needed.
//                        (Not normally needed, but some installations demand this).

class ConvertIncludePath {
    private $convertEnabled;
    private $regex;
    private $targetPath;

    public function __construct($flag, $regex, $targetPath)
    {
        $this->convertEnabled = $flag;
        $this->regex = $regex;
        $this->targetPath = $targetPath;
    }

    function convertIncludePath($path)
    {
        if ($this->convertEnabled) {
            $path = preg_replace($this->regex, $this->targetPath, $path);
        }

        return $path;
    }
}

?><?php

// formatExifData() - Formats EXIF data according to $exifFormatString.

function formatExifData ( $formatString, $exifData )
{
    // %a   Aperture
    // %c   Comment
    // %f   Flash used?
    // %i   ISO rating
    // %l   Focal length
    // %m   Camera model
    // %s   Shutter speed

    // %Y   Year
    // %M   Month
    // %D   Day
    // %T   Time

    $table = array ( 'c' => $exifData['comment'],
                     'a' => $exifData['aperture'],
                     'f' => $exifData['flash'],
                     'i' => $exifData['iso'],
                     'l' => $exifData['foclen'],
                     'm' => $exifData['model'],
                     's' => $exifData['shutter'],
                     'Y' => $exifData['year'],
                     'M' => $exifData['month'],
                     'D' => $exifData['day'],
                     'T' => $exifData['time']           );
                     
    // separate elements of format string
    $matches = explode('|', $formatString);

    $newstr = '';
    foreach ($matches as $key => $val) {
    
        // $changeflag is used to tell us if we should bother
        // printing this block at all.  If none of the format
        // characters in this block can be expanded, we never set
        // $changeflag to TRUE.  If it's not TRUE at the end of this
        // while(), the block is just dumped.
        $changeflag = FALSE;

        // Keep on going until every %X atom has been examined and
        // expanded.

        while (preg_match('#%([a-zA-Z])#', $val, $lettermatch)) {

            // which letter matched?
            $letter = $lettermatch[1];

            // If this can be expanded, do so.  If it can be,
            // set $changeflag to TRUE so we know to include this
            // block instead of dumping it.
            if (isset($table[$letter])) {
                $newtext = $table[$letter];
            } else {
                $newtext = '';
            }

            // Do interpolation
            $val = str_replace("%$letter", $newtext, $val);
        }

        $newstr .= $val;
    }
    
    return $newstr;

}   // -- End of formatExifData()

?><?php

// getExifDescription() - Fetches a comment if available from the Exif comments file (exif.inf)
//                        as well as fetching EXIF data.

function getExifDescription ( $unsafe_currDir, $formatString )
{
    global $mig_config;
    
    $aperture   = array ();
    $day        = array ();
    $desc       = array ();
    $flash      = array ();
    $foclen     = array ();
    $iso        = array ();
    $model      = array ();
    $month      = array ();
    $shutter    = array ();
    $time       = array ();
    $year       = array ();
    $knownFiles = array ();

    $localExifFilename = $mig_config['albumdir'] . "/$unsafe_currDir/exif.inf";
    if (file_exists($localExifFilename)) {

        $fname = NULL;
        $file = fopen($localExifFilename, 'r');
        $line = fgets($file, 4096);     // get first line
        while (!feof($file)) {

            if (strpos($line, 'File name    : ') === 0) {
                $fname = str_replace('File name    : ', '', $line);
                $fname = chop($fname);

                $knownFiles[$fname] = TRUE;
                $desc[$fname] = '';
                $model[$fname] = '';
                $year[$fname] = '';
                $month[$fname] = '';
                $day[$fname] = '';
                $time[$fname] = '';
                $iso[$fname] = '';
                $foclen[$fname] = '';
                $shutter[$fname] = '';
                $aperture[$fname] = '';
                $flash[$fname] = '';
            } elseif ($fname === NULL) {
                continue; // no need to parse a line that we cannot store without a filename
            } elseif (strpos($line, 'Comment      : ') === 0) {
                $comment = str_replace('Comment      : ', '', $line);
                $comment = chop($comment);
                $desc[$fname] = $comment;

            } elseif (strpos($line, 'Camera model : ') === 0) {
                $x = str_replace('Camera model : ', '', $line);
                $x = chop($x);
                $model[$fname] = $x;

            // This one apparently sometimes has a space after
            // the colon, sometimes not.  Try to work either way.
            } elseif (preg_match('#^Exposure time: ?#', $line)) {
                $x = preg_replace('#^Exposure time: ?#', '', $line);
                if (preg_match('#\(#', $x)) {
                    $x = preg_replace('#^.*\(#', '', $x);
                    $x = preg_replace('#\).*$#', '', $x);
                }
                $x = chop($x);
                $shutter[$fname] = $x;

            } elseif (strpos($line, 'Aperture     : ') === 0) {
                $x = str_replace('Aperture     : ', '', $line);
                // make it fN.N instead of f/N.N
                $x = preg_replace('#/#', '', $x);
                $x = chop($x);
                $aperture[$fname] = $x;

            } elseif (strpos($line, 'Focal length : ') === 0) {
                $x = chop(str_replace('Focal length : ', '', $line));
                if (stripos($x, '35mm equiv') !== FALSE) {
                    $x = preg_replace('#^.*alent: #', '', $x);
                    $x = chop($x);
                    $x = preg_replace('#\)$#', '', $x);
                }
                $foclen[$fname] = $x;

            } elseif (strpos($line, 'ISO equiv.   : ') === 0) {
                $x = str_replace('ISO equiv.   : ', '', $line);
                $x = chop($x);
                $iso[$fname] = $x;

            } elseif (strpos($line, 'Flash used   : Yes') === 0) {
                $flash[$fname] = $mig_config['lang']['flash_used'];

            } elseif (strpos($line, 'Date/Time    : ') === 0) {
                $x = str_replace('Date/Time    : ', '', $line);
                $x = chop($x);

                // Turn into human readable format and record
                list($w,$x,$y,$z) = parseExifDate($x);

                $year[$fname]     = $w;
                $month[$fname]    = $x;
                $day[$fname]      = $y;
                $time[$fname]     = $z;
            }

            $line = fgets($file, 4096);
        }

        fclose($file);
        
        $unsafe_image = $mig_config['unsafe_image'];

        if (!isset($knownFiles[$unsafe_image])) {
            return '';
        }
        $exifData = array ( 'comment'   => $desc[$unsafe_image],
                            'model'     => $model[$unsafe_image],
                            'year'      => $year[$unsafe_image],
                            'month'     => $month[$unsafe_image],
                            'day'       => $day[$unsafe_image],
                            'time'      => $time[$unsafe_image],
                            'iso'       => $iso[$unsafe_image],
                            'foclen'    => $foclen[$unsafe_image],
                            'shutter'   => $shutter[$unsafe_image],
                            'aperture'  => $aperture[$unsafe_image],
                            'flash'     => $flash[$unsafe_image]        );

        $retval = formatExifData($formatString, $exifData);

        return $retval;

    } else {
        return '';
    }

}   // -- End of getExifDescription()

?>
<?php

// getFileExtension() - Figure out a file's extension and return it.

function getFileExtension ( $file )
{
    // Strip off the extension part of filename
    return preg_replace('#^.*\.#', '', $file);

}   // -- End of getFileExtension()

?><?php

// getFileName() - Figure out a file's name sans extension.

function getFileName ( $file )
{
    // Strip off the non-extension part of filename
    return preg_replace('#\.[^\.]+$#', '', $file);

}   // -- End of getFileName()

?><?php

// getFileType() - Returns TRUE if filetype is supported by Mig.  More specifically, returns
//                 a string filetype.

function getFileType ( $filename )
{
    global $mig_config;
    
    $ext = getFileExtension($filename);
    $ext = strtolower($ext);

    if (in_array($ext, $mig_config['image_extensions'])) {
        return "image";
    } else if (in_array($ext, $mig_config['video_extensions'])) {
        return "video";
    } else if (in_array($ext, $mig_config['audio_extensions'])) {
        return "audio";
    } else {
        return FALSE;
    }

}   // -- End of getFileType()

?><?php

// getImageDescFromFile() - Fetches an image description from a per-image comment file
//                          (only used if $commentFilePerImage is TRUE).

function getImageDescFromFile ( $unsafe_currDir, $unsafe_image )
{
    global $mig_config;

    $imageDesc = '';
    $unsafe_fname = getFileName($unsafe_image);
    $unsafe_fname = rawurldecode($unsafe_fname);

    $short_flag = $mig_config['commentfileshortcomments'];

    $localDescFileName = $mig_config['albumdir'] . "/$unsafe_currDir/$unsafe_fname.txt";

    if (file_exists($localDescFileName)) {

        $file = fopen($localDescFileName, 'r');
        $line = fgets($file, 4096);         // get first line

        // This double-check exists so that files ending without
        // a proper newline character are not truncated.
        // This says "while (not EOF) and ($line is not empty)"...
        $short_desc = '';
        while ( $line || ! feof($file)) {
            $line = trim($line);

            // If the "short comments" flag is set, and there is
            // not yet a short description, set one.  This means this
            // must be the first line of the file.
            if ($short_flag && ! $short_desc) {
                $short_desc = $line;
            } else {
                // Otherwise just build on the main description (2nd
                // and further lines, in $firstLine mode, otherwise
                // all lines go here)
                $imageDesc .= "$line ";
            }
            $line = fgets($file, 4096); // get next line
        }

        fclose($file);

        // If there's not a long description, use the short_desc, if we
        // are in "short" mode.
        if ($short_flag && ! $imageDesc) {
            $imageDesc = $short_desc;
        }

        // If we're not in short mode, make sure there's an alt tag
        // of the comment if one exists
        if ($imageDesc && ! $short_desc) {
            $short_desc = $imageDesc;
        }

    } else {
        // File doesn't exist? Okay, return false.
        return FALSE;
    }

    return array ( trim($short_desc), trim($imageDesc) );

}   // -- End of getImageDescFromFile()

?>
<?php

// getImageDescription() - Fetches an image description from the comment file (mig.cf).

function getImageDescription($unsafe_image, $description, $short_desc)
{
    // "Long" description
    $imageDesc = '';
    if (isset($description[$unsafe_image])) {
        $imageDesc = $description[$unsafe_image];
    }

    // "Short" description
    $imageShort = '';
    if (isset($short_desc[$unsafe_image])) {
        $imageShort = $short_desc[$unsafe_image];
    }

    // Return both - let the calling code decide which to use.
    return array ($imageShort, $imageDesc);

}   // -- End of getImageDescription()

?><?php

// getNewCurrDir() - Replaces the silly old $newCurrDir being all over the place.  Especially
//                   in the URI string.

function getNewCurrDir ( $unsafe_currDir )
{
    // This just rips off the leading "./" off currDir if it exists
    $unsafe_newCurrDir = preg_replace('#^\./#', '', $unsafe_currDir);
    return migURLencode($unsafe_newCurrDir);

}   // -- End of getNewCurrDir()

?><?php

// getNumberOfDirs() - Counts subdirectories in a given folder.

function getNumberOfDirs ( $unsafe_folder )
{
    global $mig_config;
    
    if (is_dir($unsafe_folder)) {
        $dir = opendir($unsafe_folder);    // Open directory handle
    } else {
        return 0;
    }

    $count = 0;

    while ($file = readdir($dir)) {
        if ($file == '.' || $file == '..') {
            continue; // skip self and parent
        }

        // Get hidden item list from mig.cf, fills $mig_config['hidden']
        parseMigCf($unsafe_folder);

        // Must be a directory, and can't be . or ..
        if (is_dir("$unsafe_folder/$file")) {
            // Ignore thumbnail subdirectories if in use
            if ($mig_config['usethumbsubdir'] && $file == $mig_config['thumbsubdir']) {
                continue;
            }

            // And full-size directories too
            if ($mig_config['uselargeimages'] && $file == $mig_config['largesubdir']) {
                continue;
            }

            // Ignore hidden items
            if (!empty($mig_config['hidden'][$file])) {
                continue;
            }

            // Otherwise count it
            ++$count;
        }
    }
    
    return $count;

}   // -- End of getNumberOfDirs()

?><?php

// getNumberOfImages() - Counts images in a given folder.

function getNumberOfImages ( $unsafe_folder )
{
    global $mig_config;
    
    $markerLabel = $mig_config['markerlabel'];
    
    if (is_dir($unsafe_folder)) {
        $dir = opendir($unsafe_folder);    // Open directory handle
    } else {
        return 0;
    }

    $count = 0;

    // Get hidden item list from mig.cf, fills $mig_config['hidden']
    parseMigCf($unsafe_folder);

    while ($file = readdir($dir)) {
        if ($file == '.' || $file == '..') {
            continue; // skip self and parent
        }

        // Skip over thumbnails
        if (!$mig_config['usethumbsubdir']) {
                                 // unless $useThumbSubdir is set,
                                 // then don't waste time on this check

            if ($mig_config['markertype'] == 'suffix' && preg_match("#_$markerLabel\.[^.]+$#",$file)
                && getFileType($file)) {
                    continue;
            }
            if ($mig_config['markertype'] == 'prefix' && preg_match("#^$markerLabel\_#", $file)) {
                continue;
            }

        }

        // Ignore hidden items
        if (!empty($mig_config['hidden'][$file])) {
            continue;
        }

        // We'll look at this one only if it's a file and it matches our list
        // of approved extensions
        if (is_file("$unsafe_folder/$file") && getFileType($file)) {
            ++$count;
        }
    }

    return $count;

}   // -- End of getNumberOfImages()

?><?php

function _getRandomFromArray(&$list, $rand_function, $stable_order)
{
    if ($stable_order) {
        sort($list);
    }
    $randval = call_user_func($rand_function, 0, (sizeof($list) - 1));
    return $list[$randval];
}

function _findThumb($file, $unsafe_folder, $unsafe_currDir, $stable_order, $rand_function)
{
    global $mig_config;

    $dirlist = opendir($unsafe_folder);
    $subfList = array();

    $mySample = NULL;
    while ($item = readdir($dirlist)) {
        if ($item == '.' || $item == '..') {
            continue; // skip self and parent
        }

        if (is_dir("$unsafe_folder/$item")) {

            // Ignore hidden items
            if (isset($mig_config['hidden'][$item])) {
                continue;
            }

            // Ignore dot directories if appropriate
            if ($mig_config['ignoredotdirectories'] && preg_match('#^\.#', $item)) {
                continue;
            }

            // If using "real rand" create a list of folders and pick a random folder, then recurse into it.
            // Otherwise just use the first folder found, and recurse into that.
            if ($mig_config['userealrandthumbs']) {
                $subfList[] = $item;
            } else {
                $mySample = getRandomThumb($file . '/' . $item, $unsafe_folder . '/' . $item, $unsafe_currDir, $stable_order, $rand_function);
                break;
            }
        }
    }
    closedir($dirlist);

    if (!$mySample && !empty($subfList)) {
        // get random folder
        $randomItem = _getRandomFromArray($subfList, $rand_function, $stable_order);
        $mySample = getRandomThumb($file . '/' . $randomItem,
            $unsafe_folder . '/' . $randomItem, $unsafe_currDir, $stable_order, $rand_function);
    }
    return $mySample;
}

// getRandomThumb() - Find a random thumbnail to show instead of the folder icon.

function getRandomThumb($file, $unsafe_folder, $unsafe_currDir, $stable_order = FALSE, $rand_function='rand')
{
    global $mig_config;
    
    $markerLabel = $mig_config['markerlabel'];

    // SECTION ONE ...
    // If we're using thumbnail subdirectories.

    $randThumbList = array ();          // initialize
    if ($mig_config['usethumbsubdir']) {
        $unsafe_thumb_dir = $unsafe_folder . '/' . $mig_config['thumbsubdir'];

        // Does the thumb subdir exist?  Why would it not?  It would not
        // if we're in a folder that contains only other folders, for
        // example.  Or it might just not exist because no one made thumbs,
        // in which case we can't show any thumbs anyway.
        if (is_dir($unsafe_thumb_dir)) {
            $readSample = opendir($unsafe_thumb_dir);

            // Read each item in the directory...
            while ($sample = readdir($readSample)) {
                if ($sample == '.' || $sample == '..') {
                    continue; // skip self and parent
                }

                // Ignore hidden items
                if (isset($mig_config['hidden'][$sample])) {
                    continue;
                }

                // And use the first valid match found
                if (getFileType($sample)) {
                    $mySample = $mig_config['albumurlroot'] . '/'
                              . migURLencode($unsafe_currDir)
                              . '/' . migURLencode($file)
                              . '/' .$mig_config['thumbsubdir']
                              . '/' . $sample;

                    // If "real rand" is in use, add this to the
                    // list.  Otherwise just return what we found.
                    if ($mig_config['userealrandthumbs']) {
                        $randThumbList[] = $mySample;
                    } else {
                        return $mySample;
                    }
                }
            }
            closedir($readSample);

        } elseif (is_dir($unsafe_folder)) {

            // No thumb subdir exists, although $useThumbSubdir
            // is set TRUE.  We're either in a folder which has no
            // thumbs generated, or we're in a folder which contains
            // only other folders.  Iterate through items to find
            // a folder and grab an item from THAT folder, if one
            // can be found.
            //
            // This should be able to drill down as far as necessary
            // until a valid thumb is found.
            return _findThumb($file, $unsafe_folder, $unsafe_currDir, $stable_order, $rand_function);
        }

    // SECTION TWO...
    // Not using thumbnail subdirectories

    } else {

        if (!is_dir($unsafe_folder)) {
            // If it's not a directory, just bail out now.
            return FALSE;
        }

        // Open $folder as a directory handle
        $readSample = opendir($unsafe_folder);

        // Iterate through all files in this folder...
        while ($sample = readdir($readSample)) {
            if ($sample == '.' || $sample == '..') {
                continue; // skip self and parent
            }

            $mySample = NULL;    // Cleanup from last loop iteration

            // Using prefix/suffix and label settings,
            // figure out if this is a thumbnail or not.
            // This is so we skip over regular images.
            if ($mig_config['markertype'] == 'prefix') {
                if (preg_match("#^$markerLabel\_#", $sample)
                    && getFileType($sample))
                {
                    $mySample = $sample;
                }
            } elseif ($mig_config['markertype'] == 'suffix') {
                if (preg_match("#_$markerLabel\.[^.]+$#", $sample)
                    && getFileType($sample))
                {
                    $mySample = $sample;
                }

            } else {
                exit('ERROR: no markerType set in getRandomThumb()');
            }

            if ($mySample) {
                $mySample = $mig_config['albumurlroot'] . '/' . $unsafe_currDir . '/' . $file . '/' . $mySample;

                // If "real rand" is in effect, add to the list for
                // later random selection.  Otherwise just return
                // what we found.
                if ($mig_config['userealrandthumbs']) {
                    $randThumbList[] = $mySample;
                } else {
                    return $mySample;
                }

            } else {
                $mySample = _findThumb($file, $unsafe_folder, $unsafe_currDir, $stable_order, $rand_function);
                if ($mySample) {
                    return $mySample;
                }
            }
        }
        
        closedir($readSample);
    }

    if ($randThumbList) {
        return _getRandomFromArray($randThumbList, $rand_function, $stable_order); // choose random thumb
    } else {
        return FALSE;
    }

}   // -- End of getRandomThumb()

?><?php

function migHtmlSpecialChars($str) {
    global $mig_config;
    return htmlspecialchars($str, ENT_QUOTES, $mig_config['charset']);
}

?><?php

// migURLencode() - Fixes a problem where "/" turns into "%2F" when using rawurlencode().

function migURLencode ( $string )
{
    $new = rawurldecode($string);           // decode first
    $new = rawurlencode($new);              // then encode
    $new = str_replace('%2F', '/', $new);       // slash (/)

    return $new;

}   // -- End of migURLencode()

?>
<?php

// parseExifDate() - Parses an EXIF date string and returns it in a more human-readable format.

function parseExifDate ( $stamp )
{
    global $mig_config;

    // Separate into a date and a time
    $explodedDateTime = explode(' ', $stamp);
    if (count($explodedDateTime) < 2) {
        $date = $stamp;
        $time = '';
    } else {
        list($date, $time) = $explodedDateTime;
    }

    // Parse date
    $explodedDate = explode(':', $date);
    if (count($explodedDate) < 3) {
        return array('', '', '', '', '');
    }
    list($year, $month, $day) = $explodedDate;

    // Turn numeric month into a 3-character month string
    $month = $mig_config['lang']['month'][$month];

    // Parse time
    $explodedTime = explode(':', $time);
    if (count($explodedTime) == 3) {
        list($hour, $minute, $second) = $explodedTime;

        // Translate into 12-hour time
        switch ($hour) {
            case '00':
                $time = '12:' . $minute . $mig_config['lang']['am'];
                break;
            case '01':
            case '02':
            case '03':
            case '04':
            case '05':
            case '06':
            case '07':
            case '08':
            case '09':
            case '10':
            case '11':
                $time = $hour . ':' . $minute . $mig_config['lang']['am'];
                break;
            case '12':
                $time = $hour . ':' . $minute . $mig_config['lang']['pm'];
                break;
            case '13':
            case '14':
            case '15':
            case '16':
            case '17':
            case '18':
            case '19':
            case '20':
            case '21':
            case '22':
            case '23':
                $tmp = $hour - 12;
                if ($tmp < 10) {
                    $tmp = '0' . $tmp;
                }
                $time = $tmp . ':' . $minute . $mig_config['lang']['pm'];
                break;
        }
    }

    return array ( $year, $month, $day, $time );

}   // -- End of parseExifDate()

?><?php

// parseMigCf() - Parse a mig.cf file.

function _isEndOfBlock($line, $needle) {
    return $line === FALSE || stripos($line, $needle) === 0;
}

function parseMigCf ( $unsafe_folder )
{
    global $mig_config;

    // What file to parse
    $cfgfile = 'mig.cf';

    // Prototypes
    $mig_config['hidden'] = array ();
    
    $presort_dir    = array ();
    $presort_img    = array ();
    $short_desc     = array ();
    $desc           = array ();
    $ficons         = array ();
    $bulletin       = '';
    $template       = $mig_config['templatedir'] . '/folder.html';
    $fcols          = $mig_config['maxFolderColumns'];
    $tcols          = $mig_config['maxThumbColumns'];
    $maintaddr      = $mig_config['maintAddr'];
    
    $mig_config['usethumbfile'] = array ();

    // Hide thumbnail subdirectory if one is in use.
    if ($mig_config['usethumbsubdir']) {
        $mig_config['hidden'][$mig_config['thumbsubdir']] = TRUE;
    }

    // Hide large subdirectory if one is in use.
    if ($mig_config['uselargeimages']) {
        $mig_config['hidden'][$mig_config['largesubdir']] = TRUE;
    }

    $unsafe_cfgfile = "$unsafe_folder/$cfgfile";
    if (file_exists($unsafe_cfgfile)) {
        $file = fopen($unsafe_cfgfile, 'r');

        while (! feof($file)) {
            $line = fgets($file, 4096);

            // Parse <hidden> blocks
            if (stripos($line, '<hidden>') === 0) {
                $line = fgets($file, 4096);
                while (!_isEndOfBlock($line, '</hidden>')) {
                    $line = trim($line);
                    $mig_config['hidden'][$line] = TRUE;
                    $line = fgets($file, 4096);
                }
            }

            // Parse <sort> structure
            if (stripos($line, '<sort>') === 0) {
                $line = fgets($file, 4096);
                while (!_isEndOfBlock($line, '</sort>')) {
                    $line = trim($line);

                    if (is_file("$unsafe_folder/$line")) {
                        $presort_img[$line] = TRUE;
                    } elseif (is_dir("$unsafe_folder/$line")) {
                        $presort_dir[$line] = TRUE;
                    }

                    $line = fgets($file, 4096);
                }
            }

            // Parse <bulletin> structure
            if (stripos($line, '<bulletin>') === 0) {
                $line = fgets($file, 4096);
                while (!_isEndOfBlock($line, '</bulletin>')) {
                    $bulletin .= $line;
                    $line = fgets($file, 4096);
                }
            }

            // Parse <comment> structure
            if (stripos($line, '<comment') === 0) {
                $commfilename = trim($line);
                $commfilename = str_replace('">', '', $commfilename);
                $commfilename = preg_replace('#^<comment "#i','',$commfilename);
                $line = fgets($file, 4096);
                $mycomment = '';
                while (!_isEndOfBlock($line, '</comment')) {
                    $line = trim($line);
                    $mycomment .= "$line ";
                    $line = fgets($file, 4096);
                }
                $desc[$commfilename] = $mycomment;
            }

            // Parse <short> structure
            if (stripos($line, '<short') === 0) {
                $shortfilename = trim($line);
                $shortfilename = str_replace('">', '', $shortfilename);
                $shortfilename = preg_replace('#^<short "#i','',$shortfilename);
                $line = fgets($file, 4096);
                $myshort = '';
                while (!_isEndOfBlock($line, '</short')) {
                    $line = trim($line);
                    $myshort .= "$line ";
                    $line = fgets($file, 4096);
                }
                $short_desc[$shortfilename] = $myshort;
            }

            // Parse FolderIcon lines
            if (stripos($line, 'foldericon ') === 0) {
                $x = trim($line);
                list($y, $folder, $icon) = explode(' ', $x);
                $ficons[$folder] = $icon;
            }

            // Parse UseThumb lines
            if (stripos($line, 'usethumb ') === 0) {
                $x = trim($line);
                list($y, $folder, $thumbnail) = explode(' ', $x);
                $mig_config['usethumbfile'][$folder] = $thumbnail;
            }

            // Parse FolderTemplate lines
            if (stripos($line, 'foldertemplate ') === 0) {
                $x = trim($line);
                list($y, $template) = explode(' ', $x);
            }

            // Parse PageTitle lines
            if (stripos($line, 'pagetitle ') === 0) {
                $x = trim($line);
                $mig_config['pagetitle'] = preg_replace('#^pagetitle #i', '', $x);
            }

            // Parse MaintAddr lines
            if (stripos($line, 'maintaddr ') === 0) {
                $x = trim($line);
                $maintaddr = preg_replace('#^maintaddr #i', '', $x);
            }

            // Parse MaxFolderColumns lines
            if (stripos($line, 'maxfoldercolumns ') === 0) {
                $x = trim($line);
                list($y, $fcols) = explode(' ', $x);
            }

            // Parse MaxThumbColumns lines
            if (stripos($line, 'maxthumbcolumns ') === 0) {
                $x = trim($line);
                list($y, $tcols) = explode(' ', $x);
            }

        } // end of main while() loop

        fclose($file);
    }

    return array ($presort_dir, $presort_img, $desc, $short_desc,
                  $bulletin, $ficons, $template, $fcols,
                  $tcols, $maintaddr);

}   //  -- End of parseMigCf()

?>
<?php

function printPage($unsafe_currDir, $pathConvert, $unsafe_image)
{
    global $mig_config;

    // Fetch mig.cf information
    list($presort_dir, $presort_img, $desc, $short_desc, $bulletin,
        $folderIcons, $folderTemplate, $folderCols, $folderThumbCols, $folderMaintAddr)
        = parseMigCf($mig_config['albumdir'] . "/$unsafe_currDir");

    $enc_image = isset($mig_config['enc_image']) ? $mig_config['enc_image'] : '';
    // strip URL encoding here too
    $mig_config['enc_image'] = rawurldecode($enc_image);

    // if pageType is "folder") generate a folder view
    if ($mig_config['pagetype'] == 'folder') {

        // Generate some HTML to pass to the template printer

        // list of available folders
        $folderList = buildDirList($unsafe_currDir, $folderCols, $presort_dir, $folderIcons);
        // list of available images
        $imageList = buildImageList($unsafe_currDir, $folderThumbCols, $mig_config['maxThumbRows'],
            $presort_img, $desc, $short_desc);

        // Only frame the lists in table code when appropriate

        // Set style of table, either with text or thumbnails
        if ($mig_config['randomfolderthumbs']) {
            $folderTableClass = 'folderthumbs';
        } else {
            $folderTableClass = 'foldertext';
        }

        if ($folderList != '') {
            $folderList = buildTable($folderList, $folderTableClass, 'Folders Frame');
        } else if ($imageList == '') {
            // no folders and no images: add message
            $folderList = buildTable($mig_config['lang']['no_contents'], $folderTableClass, 'Folders Frame');
        }

        // We have a bulletin
        if ($bulletin != '') {
            $bulletin = buildTable('<center>' . $bulletin . '</center>', 'desc',
                'Bulletin Frame" width="60%'); //<--- kludge for now
        }

        // build the "back" link
        $backLink = buildBackLink($unsafe_currDir, 'back');

        // build the "you are here" line
        $youAreHere = buildYouAreHere($unsafe_currDir);

        // newcurrdir is currdir without the leading "./"
        $newCurrDir = getNewCurrDir($unsafe_currDir);

        // parse the template file and print to stdout
        printTemplate($folderTemplate, $folderMaintAddr, $folderList, $imageList, $backLink, '',
            $newCurrDir, '', '', '', $bulletin,
            $youAreHere, $pathConvert, '', '', '', '');


    // If pageType is "image", show an image
    } elseif ($mig_config['pagetype'] == 'image') {

        // Trick back link into going to the right place by adding
        // a bogus directory at the end
        $backLink = buildBackLink("$unsafe_currDir/blah", 'up');

        // Get the "next image" and "previous image" links, and the current
        // position (#x of y)
        list($nextLink, $prevLink, $currPos) = buildNextPrevLinks($unsafe_currDir, $presort_img);

        // Get image description
        $description = _getImageDescription($mig_config, $unsafe_currDir, $unsafe_image, $desc, $short_desc);

        // Build the "you are here" line
        $youAreHere = buildYouAreHere($unsafe_currDir);

        // Which template to use.
        $templateFile = $mig_config['templatedir'] . '/image.html';

        // newcurrdir is currdir without the leading "./"
        $newCurrDir = getNewCurrDir($unsafe_currDir);

        $largeLink = '';
        $largeHrefStart = '';
        $largeHrefEnd = '';
        $largeLinkBorder = '';
        if ($mig_config['uselargeimages'] &&
            file_exists($mig_config['albumdir'] . "/$unsafe_currDir/"
                        . $mig_config['largesubdir'] . '/' . $mig_config['unsafe_image'])) {
            $largeLink = buildLargeLink($unsafe_currDir);

            // Only build this link if we plan to use it
            if ($mig_config['largeLinkFromMedium']) {
                $largeHrefStart = buildLargeHrefStart($unsafe_currDir);
                $largeHrefEnd = '</a>';
            }

            // Use a border?
            if (!$mig_config['largeLinkUseBorders']) {
                $largeLinkBorder = ' border="0"';
            }
        }

        // Send it all to the template printer to dump to stdout
        printTemplate($templateFile, $folderMaintAddr, '', '', $backLink,
            $unsafe_currDir, $newCurrDir, $prevLink, $nextLink, $currPos,
            $description, $youAreHere, $pathConvert, $largeLink, $largeHrefStart, $largeHrefEnd,
            $largeLinkBorder);

    // If the pageType is "large", show a large image
    } elseif ($mig_config['pagetype'] == 'large') {

        // Trick the back link into going to the right place by adding
        // a bogus directory at the end
        $backLink = buildBackLink("$unsafe_currDir/blah", 'up');

        // Get the "next image" and "previous image" links, and the current
        // position (#x of y)
        list($nextLink, $prevLink, $currPos) = buildNextPrevLinks($unsafe_currDir, $presort_img);

        // Get image description
        $description = _getImageDescription($mig_config, $unsafe_currDir, $unsafe_image, $desc, $short_desc);

        // Build the "you are here" line
        $youAreHere = buildYouAreHere($unsafe_currDir);

        // Which template to use
        $templateFile = $mig_config['templatedir'] . '/large.html';

        // newcurrdir is currdir without the leading "./"
        $newCurrDir = getNewCurrDir($unsafe_currDir);

        // Send it all to the template printer to dump to stdout
        printTemplate($templateFile, $folderMaintAddr, '', '', $backLink,
            $unsafe_currDir, $newCurrDir, $prevLink, $nextLink, $currPos,
            $description, $youAreHere, $pathConvert, '', '', '', '');
    }
}

function _getImageDescription($mig_config, $unsafe_currDir, $unsafe_image, $desc, $short_desc)
{
    if ($mig_config['commentfileperimage']) {
        list($x, $description) = getImageDescFromFile($unsafe_currDir, $unsafe_image);
        // If getImageDescFromFile() returned false, get the normal
        // comment if there is one.
        if (!$description) {
            list($x, $description) = getImageDescription($unsafe_image, $desc, $short_desc);
        }
    } else {
        list($x, $description) = getImageDescription($unsafe_image, $desc, $short_desc);
    }

    if (!$description) {
        $description = '';
    }

    $exifDescription = getExifDescription($unsafe_currDir, $mig_config['exifFormatString']);

    // If there's a exifDescription but no description, just make the
    // exifDescription the description
    if ($exifDescription) {
        if ($description != '') {
            $description .= '<hr />';
        }
        $description .= $exifDescription;
    }
    return $description;
}
?>
<?php

// printTemplate() - Prints HTML page from a template file.

function printTemplate ( $templateFile, $maintAddr,
                         $folderList, $imageList, $backLink,
                         $unsafe_currDir, $newCurrDir, $prevLink,
                         $nextLink, $currPos, $description, $youAreHere,
                         $pathConvert, $largeLink, $largeHrefStart,
                         $largeHrefEnd, $largeLinkBorder )
{
    global $mig_config;

    global $REQUEST_URI;
    global $HTTP_SERVER_VARS;

    $newLang = '';
    // Get URL for %%newLang%% variable
    if (isset($_SERVER['REQUEST_URI'])) {
        $newLang = $_SERVER['REQUEST_URI'];
    } elseif (isset($HTTP_SERVER_VARS['REQUEST_URI'])) {
        $newLang = $HTTP_SERVER_VARS['REQUEST_URI'];
    } elseif (isset($REQUEST_URI)) {
        $newLang = $REQUEST_URI;
    }
    if ($newLang and strpos($newLang, 'mig_dl=') !== FALSE) {
        $newLang = preg_replace('#[?&]mig_dl=[^?&]*#', '', $newLang);
    }
    $newLang .= '&mig_dl';

    // Only prepend a path if one isn't there.  For unix-like systems this
    // checks for a leading slash, for Windows-like system it checks for
    // a leading drive letter or an SMB share.
    if (! preg_match('#^(/|[a-z]:|[\\\\]{2})#i', $templateFile)) {
        $templateFile = $mig_config['albumdir'] . '/' . $newCurrDir . '/' . $templateFile;
    }

    // Panic if the template file doesn't exist.
    if (! file_exists($templateFile)) {
        exit("ERROR: $templateFile does not exist!");
    }

    $file = fopen($templateFile,'r');    // Open template file
    $line = fgets($file, 4096);                         // Get first line

    while (! feof($file)) {             // Loop until EOF

        // Look for include directives and process them
        if (strpos($line, '#include') === 0) {
            $orig_line = $line;
            $line = trim($line);
            $line = str_replace('#include "', '', $line);
            $line = str_replace('";', '', $line);
            if (strstr($line, '/')) {
                $line = '<!-- ERROR: #include directive failed.'
                      . ' Path included a "/" character, indicating'
                      . ' an absolute or relative path.  All included'
                      . ' files must be located in the templates/'
                      . ' subdirectory. Directive was:'
                      . "\n     $orig_line\n-->\n";
                print $line;
            } else {
                $incl_file = $line;
                $templatedir = $mig_config['templatedir'];
                if (file_exists($templatedir . "/$incl_file")) {

                    if (function_exists('virtual')) {
                        // virtual() doesn't like absolute paths,
                        // apparently, so just pass it a relative one.
                        $tmplDir = preg_replace('#^.*/#', '', $templatedir);
                        virtual("$tmplDir/$incl_file");
                    } else {
                        include($pathConvert->convertIncludePath($templatedir ."/$incl_file"));
                    }

                } else {
                    // If the file doesn't exist, complain.
                    $line = '<!-- ERROR: #include directive failed.'
                          . ' Named file ' . $incl_file
                          . ' does not exist.  Directive was:'
                          . "\n    $orig_line\n-->\n";
                    print $line;
                }
            }

        } else {

            $albumURLroot		= $mig_config['albumurlroot'];
            $baseURL			= $mig_config['baseurl'];
            $enc_image			= isset($mig_config['enc_image']) ? $mig_config['enc_image'] : '';
            $unsafe_image		= isset($mig_config['unsafe_image']) ? $mig_config['unsafe_image'] : '';
            $imageSize          = '';
            $largeSubdir		= $mig_config['largesubdir'];
            $pageTitle			= $mig_config['pagetitle'];
            $charset            = $mig_config['charset'];
            $httpContentType    = $mig_config['httpContentType'];

            // Make sure this is URL encoded
            $encodedImageURL = migURLencode($unsafe_image);

            $filetype=getFileType($unsafe_image);
            // If pagetype is large, add largeSubdir to path.
            if ($filetype=='image' && $unsafe_image) {
                // Get image pixel size for <IMG> element
                $unsafe_abs_image = $mig_config['albumdir'] . "/$unsafe_currDir/" . $unsafe_image;
                if(!is_file($unsafe_abs_image)) {
                    exit("ERROR: Image file does not exist!");
				}
                if ($mig_config['pagetype'] == 'image') {
                    $imageProps = @GetImageSize($unsafe_abs_image);
                } elseif ($mig_config['pagetype'] == 'large') {
                    $unsafe_abs_large_image = $mig_config['albumdir'] . "/$unsafe_currDir/" . $mig_config['largesubdir'] . '/' . $unsafe_image;
                    $imageProps = @GetImageSize($unsafe_abs_large_image);
                } else {
                    $imageProps = FALSE;
                }
                if ($imageProps) {
                    $imageSize = $imageProps[3];
                }
            } elseif ($filetype) { // known and !image -> display icon with link
                $largeHrefStart =
                       "<a href=\"$albumURLroot/$newCurrDir/$encodedImageURL\">";
                $largeHrefEnd = "</a><br />$encodedImageURL";
                $albumURLroot='.';
                $newCurrDir='images';
                switch ($filetype) {
                    case 'video': $encodedImageURL=$mig_config['movie_icon']; break;
                    case 'audio': $encodedImageURL=$mig_config['music_icon']; break;
                    default: $encodedImageURL=$mig_config['nothumb_icon']; break;
                }
            }

            // List of valid tags
            $replacement_map = [
                'baseURL' => $baseURL,
                'maintAddr' => $maintAddr,
                'version' => $mig_config['version'],
                'folderList' => $folderList,
                'imageList' => $imageList,
                'backLink' => $backLink,
                'currDir' => migHtmlSpecialChars($unsafe_currDir),
                'newCurrDir' => $newCurrDir,
                'image' => $enc_image,
                'albumURLroot' => $albumURLroot,
                'pageTitle' => $pageTitle,
                'nextLink' => $nextLink,
                'prevLink' => $prevLink,
                'currPos' => $currPos,
                'description' => $description,
                'youAreHere' => $youAreHere,
                'distURL' => $mig_config['distURL'],
                'encodedImageURL' => $encodedImageURL,
                'imageSize' => $imageSize,
                'newLang' => $newLang,
                'largeSubdir' => $largeSubdir,
                'largeLink' => $largeLink,
                'largeHrefStart' => $largeHrefStart,
                'largeHrefEnd' => $largeHrefEnd,
                'largeLinkBorder' => $largeLinkBorder,
                'charset' => $charset,
                'httpContentType' => $httpContentType,
            ];

            // Do substitution for various variables
            foreach ($replacement_map as $key => $value) {
                $value = $value !== NULL ? $value : '';
                $line = str_replace("%%$key%%", $value, $line);
            }

            print $line;                // Print resulting line
        }
        $line = fgets($file, 4096);     // Grab another line
    }

    fclose($file);
    return TRUE;

}    // -- End of printTemplate()

?>
<?php
function replaceString($val, $formattable){

        // $changeflag is used to tell us if we should bother
        // printing this block at all.  If none of the format
        // characters in this block can be expanded, we never set
        // $changeflag to TRUE.  If it's not TRUE at the end of this
        // while(), the block is just dumped.
        $changeflag = FALSE;

     
        // Keep on going until every %X atom has been examined and
        // expanded.
     
        while (preg_match('#%([a-zA-Z])#', $val , $lettermatch)) {
  
            // which letter matched?
            $letter = $lettermatch[1];

            $newtext = '';

            // If this can be expanded, do so.  If it can be,
            // set $changeflag to TRUE so we know to include this
            // block instead of dumping it.
            if (isset($formattable[$letter])) {
                $newtext = $formattable[$letter];
                $changeflag = TRUE;
            }

            // Do interpolation
            $val = str_replace("%$letter", $newtext, $val);
         }

        $newstr = '';
        // Only if $changeflag is TRUE do we bother tacking this
        // onto the final product.
        if ($changeflag) {
            $newstr = $val;
        }
        
        return $newstr;
 }           
?><?php

// Portugese - courtesy of Fadel <fadel@fee.unicamp.br>
$mig_config['lang_lib']['br'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'voltar&nbsp;para',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'flash&nbsp;usado',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Principal',
    'must_auth'     => 'Voc&ecirc;&nbsp;deve&nbsp;entrar&nbsp;com&nbsp;um'
                     . '&nbsp;login&nbsp;e&nbsp;senha&nbsp;v&aacute;lido'
                     . '&nbsp;para&nbsp;acessar&nbsp;este&nbsp;'
                     . 'conte&uacute;do',
    'nextimage'     => 'pr&oacute;xima&nbsp;imagem',
    'no_contents'   => 'Sem&nbsp;conte&uacute;do.',
    'previmage'     => 'imagem&nbsp;anterior',
    'thumbview'     => 'Voltar&nbsp;para&nbsp;os&nbsp;thumbnails',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'subir&nbsp;um&nbsp;n&iacute;vel',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Czech - encoding iso8859-2
// courtesy of Pavel XPJ Jisl <pavel@cetoraz.info>

$mig_config['lang_lib']['cz'] = array (
       'am'            => 'AM',
       'pm'            => 'PM',
       'backhome'      => 'zpt&nbsp;dom',
       'bytes'         => '&nbsp;byt',
       'flash_used'    => 'flash&nbsp;pouit',
       'largelink'     => 'zobrazit&nbsp;velk&nbsp;obrzek',
       'largeview'     => 'zpt&nbsp;na&nbsp;zobrazen&nbsp;malch&nbs;obrzk',
       'main'          => 'Hlavn',
       'must_auth'     => 'Muste&nbsp;vloit&nbsp;sprvn&nbsp;jmno&nbsp;a'
                        . '&nbsp;heslo&nbsp;pro&nbsp;vstup',
       'nextimage'     => 'nsledujc&nbsp;obrzek',
       'no_contents'   => 'dn&nbsp;obrzky.',
       'previmage'     => 'pedchoz&nbsp;obrzek',
       'thumbview'     => 'zpt&nbsp;na&nbsp;zobrazen&nbsp;nhled',
       // total_images is special.  It has three elements you can use:
       //     %t :    Total images in folder
       //     %s :    First image shown this page
       //     %e :    Last image shown this page
       'total_images'  => 'Zobrazuji&nbsp;obrzky&nbsp;%s-%e&nbsp;z&nbsp;%t'
                        . '&nbsp;celkem<br />',
       'up_one'        => 'o&nbsp;rove&nbsp;ve',
       'month'         => array ( '01' => 'Led', '02' => 'no', '03' => 'Be',
                                  '04' => 'Dub', '05' => 'Kv', '06' => 'en',
                                  '07' => 'ec', '08' => 'Srp', '09' => 'Z',
                                  '10' => 'j', '11' => 'Lis', '12' => 'Pro' )
);

?><?php

// German - courtesy of "Burckhard Loeh" <lb@loeh.cx>
// Updated by Ekkehard Drre <ekke@doerre.net>
// Updated by Werner M. Krau <werner.krauss@hallstatt.net>
$mig_config['lang_lib']['de'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'zur&uuml;ck&nbsp;zu',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'Blitz&nbsp;benutzt',
    'largelink'     => 'Bild&nbsp;in&nbsp;voller&nbsp;Gr&ouml;&szlig;e&nbsp;betrachten',
    'largeview'     => 'zur&uuml;ck&nbps;zur&nbps;Webseitendarstellung',
    'main'          => 'Hauptverzeichnis',
    'must_auth'     => 'F&uuml;r&nbsp;den&nbsp;Zugang&nbsp;m&uuml;ssen&nbsp;'
                     . 'Sie&nbsp;eine&nbsp;g&uuml;ltige&nbsp;Benutzerkennung'
                     . '&nbsp;und&nbsp;Passwort&nbsp;eingeben',
    'nextimage'     => 'n&auml;chstes&nbsp;Bild',
    'no_contents'   => 'Kein&nbsp;Inhalt.',
    'previmage'     => 'vorheriges&nbsp;Bild',
    'thumbview'     => 'zur&uuml;ck&nbsp;zur&nbsp;Kleinbild&uuml;bersicht',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Es&nbsp;werden&nbsp;die&nbsp;Bilder&nbsp;%s-'
                     . '%e&nbsp;von&nbsp;%t&nbsp;angezeigt.<br />',
    'up_one'        => 'Eine&nbsp;Ebene&nbsp;h&ouml;her',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb',
                               '03' => 'M&auml;rz',
                               '04' => 'Apr', '05' => 'Mai', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Okt', '11' => 'Nov', '12' => 'Dez')
);

?><?php

// Danish - courtesy of Mikkel Mondrup Kristensen <mikkel@tdx.dk>
$mig_config['lang_lib']['dk'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'Tilbage&nbsp;til',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'Flash&nbsp;brugt',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Hovedside',
    'must_auth'     => 'Du&nbsp;skal&nbsp;skrive&nbsp;et&nbsp;gyldigt'
                     . '&nbsp;brugernavn&nbsp;og&nbsp;password'
                     . '&nbsp;for&nbsp;at&nbsp;komme&nbsp;ind',
    'nextimage'     => 'N&aelig;ste&nbsp;billede',
    'no_contents'   => 'Intet&nbsp;indhold.',
    'previmage'     => 'Forrige&nbsp;billede',
    'thumbview'     => 'Tilbage&nbsp;til&nbsp;oversigten',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Viser&nbsp;%s-%e&nbsp;af&nbsp;%t'
                     . '&nbsp;billeder<br />',
    'up_one'        => 'Tilbage',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'Maj', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Okt', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Estonian - courtesy of Jan Jasinski <jan@sps.ee>
$mig_config['lang_lib']['ee'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'tagasi',
    'bytes'         => '&nbsp;baiti',
    'flash_used'    => 'kasutatud&nbsp;v&auml;lku',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Avaleht',
    'must_auth'     => 'Vaatamiseks&nbsp;tuleb&nbsp;sisestada&nbsp;'
                     . 'kasutajatunnus&nbsp;ja&nbsp;arool',
    'nextimage'     => 'j&auml;rgmine&nbsp;pilt',
    'no_contents'   => 'Kataloog&nbsp;on&nbsp;t&uuml;hi',
    'previmage'     => 'eelmine&nbsp;pilt',
    'thumbview'     => 'tagasi&nbsp;ikoonide&nbsp;juurde',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'N&auml;itan&nbsp;pilte&nbsp;%s-%e&nbsp;(%t)'
                     . '&nbsp;<br />',
    'up_one'        => 'tase&nbsp;k&otilde;rgemale',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// English (default)
$mig_config['lang_lib']['en'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'back&nbsp;to',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Main',
    'must_auth'     => 'You&nbsp;must&nbsp;enter&nbsp;a&nbsp;valid'
                     . '&nbsp;username&nbsp;and&nbsp;password&nbsp;to'
                     . '&nbsp;enter',
    'nextimage'     => 'next&nbsp;image',
    'no_contents'   => 'No&nbsp;contents.',
    'previmage'     => 'previous&nbsp;image',
    'thumbview'     => 'back&nbsp;to&nbsp;thumbnail&nbsp;view',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'up&nbsp;one&nbsp;level',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Spanish - courtesy of Alex Dantart <alex@pixar.es>
// with some adjustments from JMN <umjumasa@terra.es>
$mig_config['lang_lib']['es'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'regresar&nbsp;inicio',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'flash&nbsp;usado',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Principal',
    'must_auth'     => 'Debes&nbsp;introducir&nbsp;un&nbsp;usuario&nbsp;y'
                     . '&nbsp;clave&nbsp;v&aacute;lidas&nbsp;para'
                     . '&nbsp;acceder',
    'nextimage'     => 'siguiente&nbsp;im&aacute;gen',
    'no_contents'   => 'Sin&nbsp;contenidos.',
    'previmage'     => 'anterior&nbsp;im&aacute;gen',
    'thumbview'     => 'volver&nbsp;a&nbsp;vista&nbsp;por&nbsp;iconos',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'subir&nbsp;un&nbsp;nivel',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Finnish - courtesy of Jani Mikkonen <jani@mikkonen.org>
$mig_config['lang_lib']['fi'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'takaisin',
    'bytes'         => '&nbsp;byte&auml;',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Etusivu',
    'must_auth'     => 'Sinun&nbsp;pit&auml;&auml;&nbsp;antaa&nbsp;oikea'
                     . '&nbsp;tunnus&nbsp;ja&nbsp;salasana'
                     . '&nbsp;jatkaasesi&nbsp;eteenp&nbsp;&auml;in',
    'nextimage'     => 'seuraava&nbsp;kuva',
    'no_contents'   => 'Albumi&nbsp;on&nbsp;tyhj&auml;',
    'previmage'     => 'edellinen&nbsp;kuva',
    'thumbview'     => 'takaisin&nbsp;kuva&nbsp;valikkoon',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'paluu&nbsp;edelliselle&nbsp;sivulle',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// French - courtesy of jrme ROUER <CCFRANCE.bibli@bigpond.com.kh>
//          Updated July 2002 by Yannick Mass <ymasse@henna-tatoo.net>
$mig_config['lang_lib']['fr'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'Retourner&nbsp;sur',
    'bytes'         => '&nbsp;octets',
    'flash_used'    => 'flash&nbsp;utilis&eacute;',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Liste&nbsp;des&nbsp;albums',
    'must_auth'     => 'Vous&nbsp;devez&nbsp;entrer&nbsp;un&nbsp;nom&nbsp;'
                     . 'login&nbsp;et&nbsp;un&nbsp;mot&nbsp;de&nbsp;passe'
                     . '&nbsp;valides&nbsp;pour&nbsp;entrer',
    'nextimage'     => 'Image&nbsp;suivante',
    'no_contents'   => 'VIDE',
    'previmage'     => 'Image&nbsp;pr&eacute;c&eacute;dente',
    'thumbview'     => 'Retour&nbsp;vue&nbsp;par&nbsp;vignettes',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Images&nbsp;%s&nbsp;&agrave;&nbsp;%e&nbsp;sur&nbsp;'
                     . '%t<br />',
    'up_one'        => 'Remonter&nbsp;niveau&nbsp;sup&eacute;rieur',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Courtesy of Tamas Buti <buty@axelero.hu>
$mig_config['lang_lib']['hu'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'Vissza:',
    'bytes'         => '&nbsp;byte',
    'flash_used'    => 'Vaku&nbsp;bekapcsolva',
    'largelink'     => 'Teljes&nbsp;m&eacute;ret&ucirc;&nbsp;k&eacute;p',
    'largeview'     => 'Vissza&nbsp;a&nbsp;norm&aacute;l&nbsp;m'
                     . '&eacute;rethez',
    'main'          => 'F&otilde;mappa',
    'must_auth'     => '&Eacute;rv&eacute;nyes&nbsp;jelsz&oacute;t&nbsp;'
                     . '&eacute;s&nbsp;felhaszn&aacute;l&oacute;nevet&nbsp;'
                     . 'kell&nbsp;megadni&nbsp;a&nbsp;bel&eacute;p&eacute;'
                     . 'shez',
    'nextimage'     => 'K&ouml;vetkez&otilde;',
    'no_contents'   => 'Nincs&nbsp;k&eacute;p.',
    'previmage'     => 'El&otilde;z&otilde;',
    'thumbview'     => 'Thumbnail&nbsp;k&eacute;pek',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => '%s-%e&nbsp;k&eacute;pek&nbsp;%t'
                     . '&nbsp;az&nbsp;&ouml;sszesb&otilde;l<br />',
    'up_one'        => 'Egy&nbsp;mapp&aacute;t&nbsp;fel',
    'month'         => array ( '01' => 'Jan',
                               '02' => 'Feb',
                               '03' => 'M&aacute;rc',
                               '04' => '&Aacute;pr',
                               '05' => 'M&aacute;j',
                               '06' => 'J&uacute;n',
                               '07' => 'J&uacute;l',
                               '08' => 'Aug',
                               '09' => 'Szept',
                               '10' => 'Okt',
                               '11' => 'Nov',
                               '12' => 'Dec'
                             )
);

?>
<?php

// Italian - courtesy of Marco Ermini <markoer@firenze.linux.it>
// Updated by Fabio Fioravanti <fioravanti@iasi.rm.cnr.it>
$mig_config['lang_lib']['it'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'torna&nbsp;a',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'usato&nbsp;flash',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Principale',
    'must_auth'     => 'Devi&nbsp;inserire&nbsp;un&nbsp;nome&nbsp;utente'
                     . '&nbsp;ed&nbsp;una&nbsp;password&nbsp;validi'
                     . '&nbsp;per&nbsp;accedere',
    'nextimage'     => 'prossima&nbsp;immagine',
    'no_contents'   => 'Vuoto.',
    'previmage'     => 'immagine&nbsp;precedente',
    'thumbview'     => 'torna&nbsp;alla&nbsp;vista&nbsp;per&nbsp;icone',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Immagini&nbsp;%s-%e&nbsp;di&nbsp;%t'
                     . '&nbsp;totali<br />',
    'up_one'        => 'torna&nbsp;al&nbsp;livello&nbsp;superiore',
    'month'         => array ( '01' => 'Gen', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'Mag', '06' => 'Giu',
                               '07' => 'Lug', '08' => 'Ago', '09' => 'Set',
                               '10' => 'Ott', '11' => 'Nov', '12' => 'Dic')
);


?><?php

// Japanese (UTF-8) - courtesy of Masaru Onozawa <masy@webmasters.gr.jp>
$mig_config['lang_lib']['jp'] = array (
    'am'            => '午前',
    'pm'            => '午後',
    'backhome'      => 'ホームに戻る&nbsp;-&nbsp;',
    'bytes'         => '&nbsp;バイト',
    'flash_used'    => 'フラッシュ使用',
    'largelink'     => '最大サイズの画像を見る',
    'largeview'     => '大きいサイズの画像を見る',
    'main'          => 'メインページ',
    'must_auth'     => 'この画像を見るためには ID とパスワードの入力が必要です。',
    'nextimage'     => '次の画像',
    'no_contents'   => '画像がありません',
    'previmage'     => '前の画像',
    'thumbview'     => '一覧に戻る',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => '表示中&nbsp;%s&nbsp;枚目&nbsp;'
                     . '-&nbsp;%e&nbsp;枚目&nbsp;/&nbsp;'
                     . '全画像数&nbsp;%t&nbsp;枚<br />',
    'up_one'        => '一つ上に行く',
    'month'         => array ( '01' => '1&nbsp;月',
                               '02' => '2&nbsp;月',
                               '03' => '3&nbsp;月',
                               '04' => '4&nbsp;月',
                               '05' => '5&nbsp;月',
                               '06' => '6&nbsp;月',
                               '07' => '7&nbsp;月',
                               '08' => '8&nbsp;月',
                               '09' => '9&nbsp;月',
                               '10' => '10&nbsp;月',
                               '11' => '11&nbsp;月',
                               '12' => '12&nbsp;月' )
);

?>
<?php

// Russian KOI8-R - courtesy of Anatoly Ropotov <lynx@rulez.lv>
$mig_config['lang_lib']['koi8r'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => '&times;&Aring;&Ograve;&Icirc;&Otilde;&Ocirc;&Oslash;'
                     . '&Oacute;&Ntilde;&nbsp;&Euml;',
    'bytes'         => '&nbsp;&Acirc;&Aacute;&Ecirc;&Ocirc;',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => '&igrave;&Eacute;&Atilde;&Aring;&times;&Aacute;'
                     . '&Ntilde;',
    'must_auth'     => '&divide;&Ugrave; &Auml;&Iuml;&Igrave;&Ouml;&Icirc;'
                     . '&Ugrave; &times;&times;&Aring;&Oacute;&Ocirc;&Eacute;'
                     . ' &Euml;&Iuml;&Ograve;&Ograve;&Aring;&Euml;&Ocirc;'
                     . '&Icirc;&Iuml;&Aring; &Eacute;&Iacute;&Ntilde; &ETH;'
                     . '&Iuml;&Igrave;&Oslash;&Uacute;&Iuml;&times;&Aacute;'
                     . '&Ocirc;&Aring;&Igrave;&Ntilde; &Eacute; &ETH;&Aacute;'
                     . '&Ograve;&Iuml;&Igrave;&Oslash;',
    'nextimage'     => '&Oacute;&Igrave;&Aring;&Auml;&Otilde;&Aacute;&Yacute;'
                     . '&Aacute;&Ntilde;&nbsp;&Euml;&Aacute;&Ograve;&Ocirc;'
                     . '&Eacute;&Icirc;&Euml;&Aacute;',
    'no_contents'   => '&eth;&Otilde;&Oacute;&Ocirc;&Iuml;.',
    'previmage'     => '&ETH;&Ograve;&Aring;&Auml;&Ugrave;&Auml;&Otilde;'
                     . '&Yacute;&Aacute;&Ntilde;&nbsp;&Euml;&Aacute;&Ograve;'
                     . '&Ocirc;&Eacute;&Icirc;&Euml;&Aacute;',
    'thumbview'     => '&times;&Aring;&Ograve;&Icirc;&Otilde;&Ocirc;&Oslash;'
                     . '&Oacute;&Ntilde;&nbsp;&Euml;&nbsp;&Otilde;&Iacute;'
                     . '&Aring;&Icirc;&Oslash;&Ucirc;&Aring;&Icirc;&Icirc;'
                     . '&Iuml;&Iacute;&Otilde;&nbsp;&times;&Eacute;&Auml;'
                     . '&Otilde;',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => '&ETH;&Ograve;&Aring;&Auml;&Ugrave;&Auml;&Otilde;'
                     . '&Yacute;&Aacute;&Ntilde;&nbsp;&ETH;&Aacute;&ETH;'
                     . '&Euml;&Aacute;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Dutch - courtesy of Erik@Braindisorder.org
$mig_config['lang_lib']['nl'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'Terug&nbsp;naar',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Hoofdmenu',
    'must_auth'     => 'Je&nbsp;moet&nbsp;een&nbsp;geldige&nbsp;naam&nbsp;en'
                     . '&nbsp;wachtwoord&nbsp;invoeren&nbsp;om&nbsp;hier'
                     . '&nbsp;naar&nbsp;binnen&nbsp;te&nbsp;gaan',
    'nextimage'     => 'volgende&nbsp;foto',
    'no_contents'   => 'Geen&nbsp;commentaar.',
    'previmage'     => 'vorige&nbsp;foto',
    'thumbview'     => 'terug&nbsp;naar&nbsp;overzicht',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'een&nbsp;niveau&nbsp;omhoog',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Norwegian
// Translated by Joffer aka Christopher Thorjussen - January 8th, 2000
// http://www.irc-arendal.net
$mig_config['lang_lib']['no'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'tilbake',
    'bytes'         => '&nbsp;bytes',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Galleriet',
    'must_auth'     => 'Du&nbsp;m&aring;&nbsp;oppgi&nbsp;gyldig'
                     . '&nbsp;brukernavn&nbsp;og&nbsp;passord',
    'nextimage'     => 'neste&nbsp;bilde',
    'no_contents'   => 'Tom&nbsp;katalog',
    'previmage'     => 'forrige&nbsp;bilde',
    'thumbview'     => 'tilbake&nbsp;til&nbsp;oversikt',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'opp&nbsp;et&nbsp;niv&aring;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Polish ISO-8859-2
// courtesy of Krzysztof Wojtas <krzysin@cyklon.chemia.pk.edu.pl>
$mig_config['lang_lib']['pliso'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'powr&oacute;t&nbsp;do',
    'bytes'         => '&nbsp;bajt&oacute;w',
    'flash_used'    => 'u&iquest;yto&nbsp;Flash',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'G?&oacute;wna',
    'must_auth'     => 'Musisz&nbsp;wpisa&aelig;&nbsp;prawid?ow&plusmn;'
                     . '&nbsp;nazw&ecirc;&nbsp;u&iquest;ytkownika&nbsp;i'
                     . '&nbsp;has?o&nbsp;by&nbsp;wej&para;&aelig;;',
    'nextimage'     => 'nast&ecirc;pny&nbsp;obrazek',
    'no_contents'   => 'nie&nbsp;ma&nbsp;zawarto&para;ci.',
    'previmage'     => 'poprzedni&nbsp;obrazek',
    'thumbview'     => 'powr&oacute;t&nbsp;do&nbsp;widoku&nbsp;miniatur',
    // total_images is special.  It has three elements you can use:
    //      %t :    Total images in folder
    //      %s :    First image shown this page
    //      %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'powr&oacute;t&nbsp;&nbsp;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Polish - courtesy of martvin@box43.pl
$mig_config['lang_lib']['pl'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'powr&oacute;t&nbsp;do',
    'bytes'         => '&nbsp;bajt&oacute;w',
    'flash_used'    => 'u&iquest;yto&nbsp;Flash',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'main'          => 'G&sup3;&oacute;wna',
    'must_auth'     => 'Musisz&nbsp;wpisa&aelig;&nbsp;prawid&sup3;ow&sup1;'
                     . '&nbsp;nazw&ecirc;&nbsp;u&iquest;ytkownika&nbsp;i'
                     . '&nbsp;has&sup3;o&nbsp;by&nbsp;wej&aelig;',
    'nextimage'     => 'nast&ecirc;pny&nbsp;obrazek',
    'no_contents'   => 'nie&nbsp;ma&nbsp;zawartoci.',
    'previmage'     => 'poprzedni&nbsp;obrazek',
    'thumbview'     => 'powr&oacute;t&nbsp;do&nbsp;widoku&nbsp;miniatur',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'powr&oacute;t&nbsp;&nbsp;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Romanian - courtesy of Eugen Dedu <dedu@ese-metz.fr>
$mig_config['lang_lib']['ro'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => '&icirc;napoi&nbsp;la',
    'bytes'         => '&nbsp;octeti',
    'flash_used'    => 'utilizat&nbsp;flash',
    'largelink'     => 'vedere&nbsp;marita',
    'largeview'     => '&icirc;napoi&nbsp;la&nbsp;vederea&nbsp;normala',
    'main'          => 'Principal',
    'must_auth'     => 'Pentru&nbsp;a&nbsp;intra,&nbsp;trebuie&nbsp;sa'
                     . '&nbsp;introduceti&nbsp;un&nbsp;nume&nbsp;de'
                     . '&nbsp;utilizator&nbsp;si&nbsp;o&nbsp;parola'
                     . '&nbsp;valide',
    'nextimage'     => 'imaginea&nbsp;urmatoare',
    'no_contents'   => 'Repertoriu&nbsp;GOL',
    'previmage'     => 'imaginea&nbsp;precedenta',
    'thumbview'     => '&icirc;napoi&nbsp;la&nbsp;repertoriu',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Vedere&nbsp;imaginile&nbsp;%s-%e&nbsp;din&nbsp;%t'
                     . '&nbsp;&icirc;n&nbsp;total<br />',
    'up_one'        => 'nivelul&nbsp;precedent',
    'month'         => array ( '01' => 'ian', '02' => 'feb', '03' => 'mar',
                               '04' => 'apr', '05' => 'mai', '06' => 'iun',
                               '07' => 'iul', '08' => 'aug', '09' => 'sep',
                               '10' => 'oct', '11' => 'noi', '12' => 'dec')
);


?>
<?php

// Russian Windows-1251 - courtesy of Anatoly Ropotov <lynx@rulez.lv>
$mig_config['lang_lib']['ru'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => '&acirc;&aring;&eth;&iacute;&oacute;&ograve;&uuml;'
                     . '&ntilde;&yuml;&nbsp;&ecirc;',
    'bytes'         => '&nbsp;&aacute;&agrave;&eacute;&ograve;',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => '&Euml;&egrave;&ouml;&aring;&acirc;&agrave;&yuml;',
    'must_auth'     => '&Acirc;&ucirc; &auml;&icirc;&euml;&aelig;&iacute;'
                     . '&ucirc; &acirc;&acirc;&aring;&ntilde;&ograve;&egrave;'
                     . ' &ecirc;&icirc;&eth;&eth;&aring;&ecirc;&ograve;'
                     . '&iacute;&icirc;&aring; &egrave;&igrave;&yuml; &iuml;'
                     . '&icirc;&euml;&uuml;&ccedil;&icirc;&acirc;&agrave;'
                     . '&ograve;&aring;&euml;&yuml; &egrave; &iuml;&agrave;'
                     . '&eth;&icirc;&euml;&uuml;',
    'nextimage'     => '&ntilde;&euml;&aring;&auml;&oacute;&thorn;&ugrave;'
                     . '&agrave;&yuml;&nbsp;&ecirc;&agrave;&eth;&ograve;'
                     . '&egrave;&iacute;&ecirc;&agrave;',
    'no_contents'   => '&Iuml;&oacute;&ntilde;&ograve;&icirc;.',
    'previmage'     => '&iuml;&eth;&aring;&auml;&ucirc;&auml;&oacute;&ugrave;'
                     . '&agrave;&yuml;&nbsp;&ecirc;&agrave;&eth;&ograve;'
                     . '&egrave;&iacute;&icirc;&agrave;',
    'thumbview'     => '&acirc;&aring;&eth;&iacute;&oacute;&ograve;&uuml;'
                     . '&ntilde;&yuml;&nbsp;&ecirc;&nbsp;&oacute;&igrave;'
                     . '&aring;&iacute;&uuml;&oslash;&aring;&iacute;&iacute;'
                     . '&icirc;&igrave;&oacute;&nbsp;&acirc;&egrave;&auml;'
                     . '&oacute;',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => '&iuml;&eth;&aring;&auml;&ucirc;&auml;&oacute;&ugrave;'
                     . '&agrave;&yuml;&nbsp;&iuml;&agrave;&iuml;&ecirc;'
                     . '&agrave;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Swedish - courtesy of Sebastian Djupsjbacka <basse@iki.fi>
$mig_config['lang_lib']['se'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'tillbaka',
    'bytes'         => '&nbsp;byte',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'F&ouml;rsta&nbsp;sidan',
    'must_auth'     => 'Du&nbsp;m&aring;ste&nbsp;ange&nbsp;korrekt'
                     . '&nbsp;anv&auml;ndarnamn&nbsp;och&nbsp;l&ouml;senord'
                     . '&nbsp;f&ouml;r&nbsp;att&nbsp;komma&nbsp;vidare',
    'nextimage'     => 'n&auml;sta&nbsp;bild',
    'no_contents'   => 'Det&nbsp;h&auml;r&nbsp;albumet&nbsp;&auml;r'
                     . '&nbsp;tomt',
    'previmage'     => 'f&ouml;reg&aring;ende&nbsp;bild',
    'thumbview'     => 'tillbaka&nbsp;till&nbsp;miniatyrbilderna',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'tillbaka&nbsp;till&nbsp;f&ouml;reg&aring;ende'
                     . '&nbsp;sida',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Slovenian courtesy - of Martin Vichar Donaj <martinvd@klaretinci.net>

$mig_config['lang_lib']['si'] = array (
    'am'            => 'dopoldan',
    'pm'            => 'popoldan',
    'backhome'      => 'nazaj&nbsp;k',
    'bytes'         => '&nbsp;bytov',
    'flash_used'    => 'uporablja&nbsp;flash',
    'largelink'     => 'nalo&#382;i&nbsp;polno&nbsp;velikost&nbsp;slike',
    'largeview'     => 'nazaj&nbsp;k&nbsp;web-velikosti&nbsp;slike',
    'main'          => 'Vrh',
    'must_auth'     => 'Mora&#353;&nbsp;imeti&nbsp;veljaven&nbsp;a&nbsp;vstop'
                     . '&nbsp;uporabnikIME&nbsp;in&nbsp;geslo&nbsp;za'
                     . '&nbsp;vstop',
    'nextimage'     => 'slika&nbsp;naprej',
    'no_contents'   => 'Ni&nbsp;vsebine.',
    'previmage'     => 'slika&nbsp;nazaj',
    'thumbview'     => 'index&nbsp;-&nbsp;kazalo&nbsp;',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Prikaz&nbsp;slik&nbsp;%s-%e&nbsp;od&nbsp;%t'
                     . '&nbsp;vseh<br />',
    'up_one'        => 'za&nbsp;en&nbsp;nivo&nbsp;navzgor',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'Maj', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Avg', '09' => 'Sep',
                               '10' => 'Okt', '11' => 'Nov', '12' => 'Dec')
);

?><?php

// Slovak - courtesy of Juro Polak <polak@axon.sk>
$mig_config['lang_lib']['sk'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'sp&auml;?&nbsp;na',
    'bytes'         => '&nbsp;bytov',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Hlavn&aacute;&nbsp;str&aacute;nka',
    'must_auth'     => 'Mus&iacute;te&nbsp;uvies?&nbsp;u?&iacute;vate'
                     . '&frac34;sk&eacute;&nbsp;meno&nbsp;a&nbsp;heslo&nbsp;'
                     . 'na&nbsp;vstup',
    'nextimage'     => '&iuml;al?&iacute;&nbsp;obr&aacute;zok',
    'no_contents'   => 'Pr&aacute;zdny&nbsp;adres&aacute;r.',
    'previmage'     => 'predch&aacute;dzaj&uacute;ci&nbsp;obr&aacute;zok',
    'thumbview'     => 'sp&auml;?&nbsp;na&nbsp;zmen?eniny&nbsp;obr&aacute;'
                     . 'zkov(thumbnail)',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'o&nbsp;&uacute;rove&ograve;&nbsp;vy??ie',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Turkish - courtesy of Dogan Sariguzel <dogan@procam.com.tr>
$mig_config['lang_lib']['tr'] = array (
    'am'            => 'AM',
    'pm'            => 'PM',
    'backhome'      => 'geri&nbsp;d&ouml;n:',
    'bytes'         => '&nbsp;bit',
    'flash_used'    => 'flash&nbsp;used',
    'largelink'     => 'view&nbsp;full-size&nbsp;image',
    'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
    'main'          => 'Ana',
    'must_auth'     => 'Ge&ccedil;erli&nbsp;bir&nbsp;kullan&yacute;c&yacute;'
                     . '&nbsp;ad&yacute;&nbsp;ve&nbsp;&thorn;ifre'
                     . '&nbsp;girmelisiniz.',
    'nextimage'     => 'sonraki&nbsp;resim',
    'no_contents'   => 'i&ccedil;erik&nbsp;yok.',
    'previmage'     => '&ouml;nceki&nbsp;resim',
    'thumbview'     => 'k&uuml;&ccedil;&uuml;k&nbsp;resimlere&nbsp;geri'
                     . '&nbsp;d&ouml;n',
    // total_images is special.  It has three elements you can use:
    //     %t :    Total images in folder
    //     %s :    First image shown this page
    //     %e :    Last image shown this page
    'total_images'  => 'Showing&nbsp;images&nbsp;%s-%e&nbsp;of&nbsp;%t'
                     . '&nbsp;total<br />',
    'up_one'        => 'bir&nbsp;seviye&nbsp;yukar&yacute;',
    'month'         => array ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar',
                               '04' => 'Apr', '05' => 'May', '06' => 'Jun',
                               '07' => 'Jul', '08' => 'Aug', '09' => 'Sep',
                               '10' => 'Oct', '11' => 'Nov', '12' => 'Dec')
);


?><?php

// Traditional Chinese (big5)
// Courtesy of Belle Liu <belle@belleliu.com>
$mig_config['lang_lib']['zh'] = array (
     'am'            => 'W',
     'pm'            => 'U',
     'backhome'      => '^',
     'bytes'         => '&nbsp;줸',
     'flash_used'    => 'ΰ{O',
     'largelink'     => 'view&nbsp;full-size&nbsp;image',
     'largeview'     => 'back&nbsp;to&nbsp;web-sized&nbsp;view',
     'main'          => 'D',
     'must_auth'     => 'AJĪΤW٤αKX~iiJ',
     'nextimage'     => 'U@iϤ',
     'no_contents'   => 'Se',
     'previmage'     => 'W@iϤ',
     'thumbview'     => '^Y˵',
     // total_images is special.  It has three elements you can use:
     //     %t :    Total images in folder
     //     %s :    First image shown this page
     //     %e :    Last image shown this page
     'total_images'  => '%tiϤ%s-%ei',
     'up_one'        => '^W@h',
     'month'         => array ( '01' => '@', '02' => 'G',
                                '03' => 'T', '04' => '|',
                                '05' => '', '06' => '',
                                '07' => 'C', '08' => 'K',
                                '09' => 'E', '10' => 'Q',
                                '11' => 'Q@', '12' => 'QG' )
);


?><?php

error_reporting($error_reporting);

// URL to use to call myself again
if (isset($_SERVER['PHP_SELF'])) {
    $mig_config['baseurl'] = $_SERVER['PHP_SELF'];
} elseif (isset($HTTP_SERVER_VARS['PHP_SELF'])) {
    $mig_config['baseurl'] = $HTTP_SERVER_VARS['PHP_SELF'];
} elseif (isset($PHP_SELF)) {
    $mig_config['baseurl'] = $PHP_SELF;
} elseif (isset($_SERVER['SCRIPT_NAME'])) {
    $mig_config['baseurl'] = $_SERVER['SCRIPT_NAME'];
} elseif (isset($HTTP_SERVER_VARS['SCRIPT_NAME'])) {
    $mig_config['baseurl'] = $HTTP_SERVER_VARS['SCRIPT_NAME'];
} elseif (isset($SCRIPT_NAME)) {
    $mig_config['baseurl'] = $SCRIPT_NAME;
} else {
    exit('FATAL ERROR: Could not set baseurl');
}

// Base directory of installation
if (isset($_SERVER['PATH_TRANSLATED'])) {
    $mig_config['basedir'] = $_SERVER['PATH_TRANSLATED'];
} elseif (isset($HTTP_SERVER_VARS['PATH_TRANSLATED'])) {
    $mig_config['basedir'] = $HTTP_SERVER_VARS['PATH_TRANSLATED'];
} elseif (isset($PATH_TRANSLATED)) {
    $mig_config['basedir'] = $PATH_TRANSLATED;
} elseif (isset($_SERVER['SCRIPT_FILENAME'])) {
    $mig_config['basedir'] = $_SERVER['SCRIPT_FILENAME'];
} elseif (isset($HTTP_SERVER_VARS['SCRIPT_FILENAME'])) {
    $mig_config['basedir'] = $HTTP_SERVER_VARS['SCRIPT_FILENAME'];
} elseif (isset($SCRIPT_FILENAME)) {
    $mig_config['basedir'] = $SCRIPT_FILENAME;
} else {
    exit('FATAL ERROR: Can not set basedir');
}

// Strip down to just directory name
$mig_config['basedir'] = dirname($mig_config['basedir']);

// Strip extra slashes out of basedir if appropriate
// This is basically for Windows SMB shares
if (preg_match('#^[\\\\]{2}#i', $mig_config['basedir'])) {
    $mig_config['basedir'] = stripslashes($mig_config['basedir']);
}

// Locate and load configuration
if (file_exists($mig_config['basedir'].'/mig/config.php')) {
    // Found it - we're in Nuke mode
    $configFile = $mig_config['basedir'].'/mig/config.php';
} elseif (file_exists($mig_config['basedir'].'/config.php')) {
    // Found it - regular mode
    $configFile = $mig_config['basedir'].'/config.php';
}

$pathConvert = new ConvertIncludePath($pathConvertFlag, $pathConvertRegex, $pathConvertTarget);

// Include config file, making sure to modify the include path if appropriate.
if (isset($configFile)) {
    $configFile = $pathConvert->convertIncludePath($configFile);
    include($configFile);
}

$mig_config['albumdir'] = $mig_config['basedir'] . $albumRoot;   // Where albums live

// apply open_basedir restrictions (if enabled)
/** @psalm-suppress TypeDoesNotContainType */
if ($migOpenBasedir === TRUE) {
    $openBasedirs = $migOpenBasedirExtraDirs;
    if (isset($configFile)) {
        array_push($openBasedirs, $configFile);
    }
    array_push($openBasedirs, $mig_config['albumdir']);
    array_push($openBasedirs, $mig_config['basedir'] . '/templates');
    ini_set('open_basedir', implode(PATH_SEPARATOR, $openBasedirs));
}

//for old compatibility: remove in mig 2.0:
/** @psalm-suppress TypeDoesNotContainType */
if ($suppressImageInfo == TRUE) {
    $fileInfoFormatString['image'] = "%n";
    $fileInfoFormatString['audio'] = "%n";
    $fileInfoFormatString['video'] = "%n";
}

// Fetch some settings into $mig_config
$mig_config['commentfileperimage']              = $commentFilePerImage;
$mig_config['commentfileshortcomments']         = $commentFileShortComments;
$mig_config['fileinfoformatstring']             = $fileInfoFormatString;
$mig_config['foldernamelength']                 = $folderNameLength;
$mig_config['foldersorttype']                   = $folderSortType;
$mig_config['homelabel']                        = $homeLabel;
$mig_config['homelink']                         = $homeLink;
$mig_config['ignoredotdirectories']             = $ignoreDotDirectories;
$mig_config['imagepoplocationbar']              = $imagePopLocationBar;
$mig_config['imagepopmaxheight']                = $imagePopMaxHeight;
$mig_config['imagepopmaxwidth']                 = $imagePopMaxWidth;
$mig_config['imagepoptoolbar']                  = $imagePopToolBar;
$mig_config['imagepoptype']                     = $imagePopType;
$mig_config['imagepopup']                       = $imagePopup;
$mig_config['largesubdir']                      = $largeSubdir;
$mig_config['nextformatstring']                 = $nextFormatString;
$mig_config['nothumbs']                         = $noThumbs;
$mig_config['omitimagename']                    = $omitImageName;
$mig_config['randomfolderthumbs']               = $randomFolderThumbs;
$mig_config['pagetitle']                        = $pageTitle;
$mig_config['prevformatstring']                 = $prevFormatString;
$mig_config['showshortonthumbpage']             = $showShortOnThumbPage;
$mig_config['sorttype']                         = $sortType;
$mig_config['suppressalttags']                  = $suppressAltTags;
$mig_config['suppressimageinfo']                = $suppressImageInfo;
$mig_config['thumbext']                         = $thumbExt;
$mig_config['thumbsubdir']                      = $thumbSubdir;
$mig_config['uselargeimages']                   = $useLargeImages;
$mig_config['userealrandthumbs']                = $useRealRandThumbs;
$mig_config['usethumbsubdir']                   = $useThumbSubdir;
$mig_config['viewfoldercount']                  = $viewFolderCount;
$mig_config['imageFilenameRegexpr']             = $imageFilenameRegexpr;
$mig_config['currDirNameRegexpr']               = $currDirNameRegexpr;
$mig_config['charset']                          = $migCharset;
$mig_config['httpContentType']                  = $httpContentType;
$mig_config['music_icon']                       = $music_icon;
$mig_config['movie_icon']                       = $movie_icon;
$mig_config['folder_icon']                      = $folder_icon;
$mig_config['nothumb_icon']                     = $nothumb_icon;
$mig_config['showTotalImagesString']            = $showTotalImagesString;
$mig_config['image_extensions']                 = $image_extensions;
$mig_config['video_extensions']                 = $video_extensions;
$mig_config['audio_extensions']                 = $audio_extensions;
$mig_config['maintAddr']                        = $maintAddr;
$mig_config['maxFolderColumns']                 = $maxFolderColumns;
$mig_config['maxThumbColumns']                  = $maxThumbColumns;
$mig_config['maxThumbRows']                     = $maxThumbRows;
$mig_config['version']                          = $version;
$mig_config['distURL']                          = $distURL;
$mig_config['exifFormatString']                 = $exifFormatString;
$mig_config['largeLinkFromMedium']              = $largeLinkFromMedium;
$mig_config['largeLinkUseBorders']              = $largeLinkUseBorders;

function getHttpGetVariable($name, $default = '') {
    global $HTTP_GET_VARS;
    if (isset($_GET[$name])) {
        return $_GET[$name];
    } elseif (isset($HTTP_GET_VARS[$name])) {
        return $HTTP_GET_VARS[$name];
    }
    return $default;
}

function getHttpServerVariable($name, $default = '') {
    global $HTTP_SERVER_VARS;
    if (isset($_SERVER[$name])) {
        return $_SERVER[$name];
    } elseif (isset($HTTP_SERVER_VARS[$name])) {
        return $HTTP_SERVER_VARS[$name];
    }
    return $default;
}

function migRedirect($path)
{
    global $mig_config, $URI_SCHEME, $SERVER_NAME, $SERVER_PORT;
    $redirectTarget = $SERVER_NAME ? "$URI_SCHEME://$SERVER_NAME:$SERVER_PORT" : '';
    $relUrl = $mig_config['baseurl'] . $path;
    header("Location: $redirectTarget$relUrl");
    return 0;
}

if (! isset($SERVER_NAME)) {
    $SERVER_NAME = getHttpServerVariable('SERVER_NAME');
}

if (! isset($SERVER_PORT)) {
    $SERVER_PORT = getHttpServerVariable('SERVER_PORT', '80');
}

if (! isset($PATH_INFO)) {
    $PATH_INFO = getHttpServerVariable('PATH_INFO');
}

$URI_SCHEME = getHttpServerVariable('HTTPS') === 'on' ? 'https' : 'http';

// Jump has to come before currDir redirect to work
$jump = getHttpGetVariable('jump', FALSE);
// Is this a jump-tag URL?
if ($jump && isset($jumpMap[$jump])) {
    exit(migRedirect("?$jumpMap[$jump]"));
}
unset($jump);

// Jump-tag using PATH_INFO rather than "....?jump=x" URI
if (isset($PATH_INFO) && isset($jumpMap[$PATH_INFO])) {
    exit(migRedirect("?$jumpMap[$PATH_INFO]"));
}


// Get currDir.  If there isn't one, default to "."
$unchecked_currDir = getHttpGetVariable('currDir');
if (!$unchecked_currDir) {
    exit(migRedirect('?currDir=.'));
}

function is_in_album_dir($relative_path) {
    global $mig_config;
    $albumdir_abs = realpath($mig_config['albumdir']);
    $unchecked_abs_path = "$albumdir_abs/$relative_path";
    return string_starts_with(realpath($unchecked_abs_path), $albumdir_abs);
}

// Get rid of \'s if magic_quotes_gpc is turned on (causes problems).
if (_get_magic_quotes_gpc() == 1) {
    $unchecked_currDir = stripslashes($unchecked_currDir);
}

// Look at currDir from a security angle.  Don't let folks go outside
// the album directory base
if (strstr($unchecked_currDir, '..') || !preg_match($mig_config['currDirNameRegexpr'], $unchecked_currDir)) {
    exit('SECURITY VIOLATION - ABANDON SHIP');
}

// Try to validate currDir
//     Must be either "." (root) or,
//     must begin with "./" and dot or slash can't follow that
//     for at least two positions.
//
if ($unchecked_currDir != '.' && !preg_match('#^./[^/][^/]*#', $unchecked_currDir)) {
    exit('ERROR: $currDir is invalid. Exiting.');
}

// currDir may not end in / unless it is './' in its entirety
if ($unchecked_currDir != './' && preg_match('#/$#', $unchecked_currDir)) {
    exit('ERROR: $currDir has invalid format. Exiting.');
}

// double check: currDir must be in album dir (no directory traversal)
// This is an extra check in case someone sets $currDirNameRegexpr to a value that does not include directory traversal
// protection AND has open_basedir disable, quickly check if the absolute path of the image is inside the absolute path
// of our album dir.
// Note: this also requires the path to exist
if (!is_in_album_dir("$unchecked_currDir")) {
    exit("ERROR: Failed to load currDir " . migHtmlSpecialChars($unchecked_currDir));
}

// Strip URL encoding
$unchecked_currDir = rawurldecode($unchecked_currDir);
$unsafe_currDir = $unchecked_currDir; // upgrade to unsafe ("we checked it, but it's not safe for HTML/XSS purpose")
unset($unchecked_currDir); // remove unchecked GET parameter entirely

// Get image, if there is one.
$unchecked_image = getHttpGetVariable('image');

// Get rid of \'s if magic_quotes_gpc is turned on (causes problems).
if (_get_magic_quotes_gpc() == 1 && $unchecked_image) {
    $unchecked_image = stripslashes($unchecked_image);
}

// Look at $unchecked_image from a security angle.
// Don't let folks go outside the album directory base
// Don't let folks define ANY directory here
if (strstr($unchecked_image, '/') || strstr($unchecked_image, '\\') // image is never a full path
    || strstr($unchecked_image, '..') // basic directory traversal check, see below for more
    || !preg_match($mig_config['imageFilenameRegexpr'], $unchecked_image)) {
    exit('ERROR: $image is invalid.  Exiting.');
}

// double check: directory of image must be in album dir, no directory traversal (see comment for currDir above)
if ($unchecked_image && !is_in_album_dir($unsafe_currDir . '/' . dirname($unchecked_image))) {
    exit('ERROR: $image is not allowed. Exiting.');
}

$unsafe_image = $unchecked_image; // upgrade to unsafe ("we checked it, but it's not safe for HTML/XSS purpose")
unset($unchecked_image); // remove unchecked GET parameter entirely
$mig_config['unsafe_image'] = $unsafe_image;
$mig_config['enc_image'] = migHtmlSpecialChars($unsafe_image);

// check if the image exists...
if ($unsafe_image && !file_exists($mig_config['albumdir']."/$unsafe_currDir/".$unsafe_image)) {
    exit("ERROR: ".migHtmlSpecialChars($unsafe_currDir)."/".$mig_config['enc_image']." is invalid.  Exiting.");
}



// Get pageType.  If there isn't one, default to "folder"
$unsafe_pageType = getHttpGetVariable('pageType', 'folder');

// only allow one of the predefined values
$allowedTypes = array( "image" => 1, "folder" => 1, "large" => 1, "" => 1);

if(!isset($allowedTypes[$unsafe_pageType])) {
    exit('ERROR: $pageType is invalid.  Exiting.');
} else {
    $mig_config['pagetype'] = $unsafe_pageType; // pageType is now safe because it's from our allowed list
    unset($unsafe_pageType);
}
unset($allowedTypes);


// only allow digits for $startFrom
$mig_config['startfrom'] = intval(getHttpGetVariable('startFrom', 0));

// use language set specified in URL, if one was.
$unsafe_mig_dl = getHttpGetVariable('mig_dl', '');
// Only use it if we find it - otherwise fall back to default language
if (isset($mig_config['lang_lib'][$unsafe_mig_dl])) {
    $mig_language = $unsafe_mig_dl; // if the language was in our lang_lib, it is safe to use
    $mig_config['mig_dl'] = $mig_language;
} else {
    $mig_config['mig_dl'] = '';
}
unset($unsafe_mig_dl);


// Grab appropriate language from library
$mig_config['lang'] = $mig_config['lang_lib'][$mig_language];

// Backward compatibility with older config.php/mig.cfg versions
if (isset($maxColumns)) {
    $maxThumbColumns = $maxColumns;
}

// Turn off magic_quotes_runtime (causes trouble with some installations)
// (This method is deprecated as of 5.3, so only call it if the function exists)
if (function_exists('set_magic_quotes_runtime')) {
    /** @noinspection PhpDeprecationInspection */
    @set_magic_quotes_runtime(false);
}


//
// Handle any password authentication needs
//

$unsafe_workCopy = $unsafe_currDir;

while ($unsafe_workCopy) {

    if (isset($protect[$unsafe_workCopy])) {
        exit('password protection is not supported anymore');
    }

    // if $workCopy is already down to "." just nullify to end loop
    if ($unsafe_workCopy == '.') {
        $unsafe_workCopy = FALSE;
    } else {
        // parse $workCopy down one directory at a time
        // so we can check back all the way to "."
        $unsafe_workCopy = preg_replace('#/[^/]+$#', '', $unsafe_workCopy);
    }
}

// send Content-Type
header('Content-Type: '.$httpContentType);

// Where templates live
$mig_config['templatedir'] = $mig_config['basedir'] . '/templates';

// baseURL with the scriptname torn off the end
$baseHref = preg_replace('#/[^/]+$#', '', $mig_config['baseurl']);

// Location of image library (for instance, where icons are kept)
$mig_config['imagedir'] = $baseHref . '/images';

// Root where album images are living
$mig_config['albumurlroot'] = $baseHref . $albumRoot;
// NOTE: Sometimes Windows users have to set this manually, like:
// $mig_config['albumurlroot'] = '/mig/albums';

// Well, GIGO... set default to sane if someone screws up their
// config file

/** @psalm-suppress RedundantCondition,TypeDoesNotContainType */
if ($markerType != 'prefix' && $markerType != 'suffix' ) {
    $markerType = 'suffix';
}
$mig_config['markertype'] = $markerType;

/** @psalm-suppress TypeDoesNotContainType */
if (! $markerLabel) {
    $markerLabel = 'th';
}
$mig_config['markerlabel'] = $markerLabel;

/** @psalm-suppress TypeDoesNotContainType */
if (! $mig_config['foldersorttype']) {
    // Override folder sort if not present
    $mig_config['foldersorttype'] = $mig_config['sorttype'];
}

printPage($unsafe_currDir, $pathConvert, $unsafe_image);

?>
